--//------------------------------------------------------------------------
--//
--//	X
--//
--//	CHROME TEST
--//
--//	CONFIDENTIAL
--//	Copyright (c) 1996, Sega Technical Institute
--//
--//	AUTHOR
--//  CHRIS COFFIN
--//
--//	TARGET
--//	SEGA SATURN
--//
--//	REVISION 
--//	00/00/00
--//
--//	ORIGINAL FILE 
--//	s:\sgl_3\sgl\sample\chrome\main.c
--//
--//------------------------------------------------------------------------
--


function GRreal(n) return 0x1c38+n end


local len = GFS_Load_name("DATA.BIN", 0, CPU_WRAM_LO, CPU_WRAM_LO_LEN)-- filename case sensitive !!!!
if len == nil or len <= 0 then
	slPrint("Error loading data file!", 9, 3)
end
-- imediately make remaining low workram available for Lua
len = bit.band(len + 3, 0xFFFFFFFB)-- round up to 4 byte boundary
bpool(CPU_WRAM_LO+len, CPU_WRAM_LO_LEN-len)


local tex_table    = CPU_WRAM_LO + 0xb00
local pic_table    = CPU_WRAM_LO + 0xaf0
local xpdata_test  = CPU_WRAM_LO + 0x02c
local grreal_test  = CPU_WRAM_LO + 0x914
local tex_palette  = CPU_WRAM_LO + 0xd50
local GourTbl      = CPU_WRAM_LO + 0xab0
local gour_palette = CPU_WRAM_LO + 0xa70

local vwork = getnewuserdata(1024)



-- texture.c								   
local NUM_TEXTURES = 1
local TEX_COL_ADR  = (VDP2_COLRAM	+ 0x00800)
function Texture_Load()
	-- DMA TEXTURE TO VDP1 VRAM
	set_texture(tex_table, pic_table, NUM_TEXTURES)
	-- Load custom FX palette that textures reference	
	Pal2CRAM(tex_palette, TEX_COL_ADR , 256)
end


local t_angX,t_angY,t_angZ = 0, 0, 0

local light = {}
local cm_pos    = {X=0.0, Y=-1.0, Z=-35.0 }
local cm_target = {X=0.0, Y= 0.0, Z=  0.0 }
local cm_ang    = {X=DEGtoANG(0.0), Y=DEGtoANG(0.0), Z=DEGtoANG(0.0) }


slInitSystem(TV_352x256, tex_table, 1)		-- INITIALIZE SGL
Texture_Load()								-- INITALIZE ALL TEXTURES (texture.c)


slInitGouraud( grreal_test, 1024, GRreal(0), vwork )
slIntFunction( slGouraudTblCopy )			-- Register gouraud table copy function
slZdspLevel(7)								-- Set Z display level

slSetGouraudTbl( GourTbl )					-- Specify custom gouraud table
slDMACopy( gour_palette, VDP2_COLRAM, 64 )
slCurColor(15)								-- specify text color

slPrint("Chrome/Bump demo"	, 1, 23)
slPrint("SGL 3.0"			, 1, 24)
slPrint("Powered by Saturn Lua Player", 1, 25)


slPrint("V Count"			, 1, 2)
slPrint("Polys Processed"	, 1, 3)
slPrint("Polys Drawn"		, 1, 4)
slPrint("TotalVertices"		, 1, 5)



-- LIGHT VECTOR IN SCENE
light.X = 0.0
light.Y = 0.851
light.Z = 0.451

-- SET LIGHT VECTOR IN SGL
slLight(light)

-- MAIN LOOP

local mask = bit.bor(PER_DGT_ST, PER_DGT_TA, PER_DGT_TB, PER_DGT_TC)

while true do
	-- Get unit matrix and specify camera line of sight in world
	slUnitMatrix(CURRENT)
	slLookAt(cm_pos, cm_target, cm_ang.Z )

	-- SPIN OBJECT
	slRotZ(t_angZ)
	slRotY(t_angY)			   
	slRotX(t_angX)
							 
	t_angZ = t_angZ + DEGtoANG(0.25)
	t_angY = t_angY + DEGtoANG(1.0)
	t_angX = t_angX + DEGtoANG(1.1)

	-- DRAW OBJECT
	slPutPolygonX(xpdata_test, light)

	-- DEBUG INFO
	slPrintHex(	slHex2Dec(TotalPolygons()), 16, 3)
	slPrintHex(	slHex2Dec(DispPolygons() ), 16, 4)
	slPrintHex(	slHex2Dec(TotalVertices()), 16, 5)
	slPrintHex(	slHex2Dec(slGetVCount()  ), 16, 2)	-- Get vertical count position
	
    local id,ext,data = Smpc_Peripheral(0)
	if bit.bxor(data, mask) == 0xFFFF then
		SYS_Exit(0)
	end
	slSynch()	-- SYNC SGL
end


