REM This script is for debugging your Lua code. Line numbers are preserved, the Lua script is not changed.
REM This way, if Lua gives an error message with a line number, you can easily navigate to that line of Lua code.


REM Get newest executable of Saturn Lua Player
copy ..\..\build\saturn\cd\0.bin cd\

REM Get some tools needed
copy ..\..\tools\mkisofs.exe .
copy ..\..\tools\cygwin1.dll .
copy ..\..\tools\lstrip\lstrip.exe .

REM Set the Lua script to be executed by Saturn Lua Player
REM Preserve line numbers
copy cd\0_orig.lua cd\0.lua

REM Create ISO CD image
mkisofs -quiet -sysid "SEGA SATURN" -volid "SaturnApp" -volset "SaturnApp" -publisher "SEGA ENTERPRISES, LTD." -preparer "SEGA ENTERPRISES, LTD." -appid "SaturnApp" -abstract "ABS.TXT" -copyright "CPY.TXT" -biblio "BIB.TXT" -generic-boot ../ip.bin -full-iso9660-filenames -o sample.iso cd

REM Delete temporary copies of tools
del mkisofs.exe
del cygwin1.dll
del lstrip.exe

REM PAUSE
