--/***************************************************
--
--  sample for backupram
--
--***************************************************/


local FILE_NAME     = "FILE_NAME01"
local BACKUP_DEVICE = 0
local TEST_DATA     = "It's a pen"
local TEST_SIZE     = 10
local DIR_SIZE      = 8
function HEX2DEC(x)	return bit.band(0x0f, x) + bit.rshift(x, 4)*10 end



local dir    = {}
local dirs

local buf    = getnewuserdata(256)
local lin    = 4


slInitSystem(TV_352x224, NULL, 1) 

slPrint("Sample program Backup Library" , 9, 2)
slPrint("Powered by Saturn Lua Player", 9, 3)

slGetStatus() 
for i=1,100 do slSynch() end

local BackUpRamWork, conf = BackUpInit() -- Importand: keep variable BackUpRamWork as long as you use BUP library
    
local status, sttb = BUP_Stat( BACKUP_DEVICE, TEST_SIZE )
if status == BUP_UNFORMAT then
	local tmp
	status = BackUpFormat(BACKUP_DEVICE)
	slPrint("Formatting device" , 10, lin)
	tmp, sttb = BUP_Stat( BACKUP_DEVICE, TEST_SIZE )
end

if sttb.freeblock > 0 then
	lin = lin+1
	slPrint("Writing file." , 10, lin)
	lin = lin+1
	slPrint("Filename= "    , 13, lin)
	slPrint(  FILE_NAME     , 23, lin)

	dir.filename = FILE_NAME
	dir.comment  = "Test desu"
	dir.language = BUP_ENGLISH
	dir.size     = TEST_SIZE
	status = BackUpWrite(BACKUP_DEVICE, dir, TEST_DATA, OFF)
	status = BUP_Verify (BACKUP_DEVICE, FILE_NAME, TEST_DATA)
end

status, dirs = BUP_Dir ( BACKUP_DEVICE, FILE_NAME, DIR_SIZE )
status, dirs = BUP_Dir ( BACKUP_DEVICE, "", DIR_SIZE )

lin = lin+1
slPrint("status: " .. status .. ", #dirs: " .. #dirs, 2, lin)


for i=1,#dirs do
	--	  char	cmnt[11] = "Dirs    = ";
	--	  cmnt[6] = (char)(i+20)
	lin = lin+1
	slPrint("Dirs   = "     , 10, lin)
	slPrint(dirs[i].filename, 20, lin)
end


dir.filename = FILE_NAME
dir.comment  = "Test desu"
dir.language = BUP_ENGLISH
dir.size     = TEST_SIZE
status = BackUpWrite(BACKUP_DEVICE, dir, TEST_DATA, OFF)
status = BUP_Read( BACKUP_DEVICE, FILE_NAME, buf)
lin = lin+1
slPrint("Reading file." , 10, lin)
lin = lin+1
slPrint("Filename= "    , 13, lin)
slPrint( FILE_NAME      , 23, lin)

--    status = BackUpDelete( BACKUP_DEVICE, FILE_NAME )
--    status = BUP_Dir ( BACKUP_DEVICE, "", DIR_SIZE, dirs )
--    lin = lin+1
--    slPrint("Deleting ="    , 10, lin)
--    lin = lin+1
--    slPrint("Filename= "    , 13, lin)
--    slPrint( FILE_NAME      , 23, lin)

for i=1,#dirs do
	--	  char	cmnt[11] = "Dirs    = ";
	--	  cmnt[6] = (char)(i+20);
	lin = lin+1
	slPrint("Dirs   = "     , 10, lin)
	slPrint(dirs[i].filename, 20, lin)
end

BackUpRamWork = nil -- finished with BUP library

while true do slSynch() end
      

