--/*----------------------------------------------------------------------*/
--/*	Window & Clipping						*/
--/*----------------------------------------------------------------------*/

local Zlimit	= 150
local CENTER_X	= 160
local CENTER_Y	= 112

local ang1, ang2 = {}, {}
local pos1, pos2 = {}, {}
local left, top, right, bottom = 130, 30, 190, 80
local v_move, h_move = 1, 1

slInitSystem(TV_320x224,NULL,1)
slPrint("Sample program 4.5" , 9, 2)
slPrint("Powered by Saturn Lua Player", 9, 3)

ang1.X = DEGtoANG(0.0)
ang1.Y = ang1.X
ang1.Z = ang1.X 
ang2.X = DEGtoANG(30.0)
ang2.Y = DEGtoANG(0.0)
ang2.Z = ang2.Y
pos1.X = 0.0
pos1.Y = 0.0
pos1.Z = 190.0
pos2.X = pos1.X
pos2.Y = pos1.Y
pos2.Z = pos1.Z

-- Note: GFS_Init() has already been called in the Saturn Lua Player
local len = GFS_Load_name("DATA.BIN", 0, CPU_WRAM_LO, CPU_WRAM_LO_LEN)-- filename case sensitive !!!!
if len == nil or len <= 0 then
	slPrint("Error loading data file!", 9, 3)
end
local PD_CUBE  = CPU_WRAM_LO
local PD_PLANE = CPU_WRAM_LO + 0x14

local mask = bit.bor(PER_DGT_ST, PER_DGT_TA, PER_DGT_TB, PER_DGT_TC)

while true do
	left   = left   + v_move
	top    = top    + h_move 
	right  = right  + v_move
	bottom = bottom + h_move
	
	if left   == 0   then v_move =  1 end
	if top    == 0   then h_move =  1 end
	if right  == 319 then v_move = -1 end
	if bottom == 223 then h_move = -1 end
	
	slWindow(left, top, right, bottom, Zlimit, CENTER_X, CENTER_Y)
	
	slPushMatrix()
		slTranslate(pos1.X, pos1.Y, pos1.Z)
		slRotX(ang1.X)
		slRotY(ang1.Y)
		slRotZ(ang1.Z)
		slPutPolygon(PD_PLANE)		
	slPopMatrix()
	
	slPushMatrix()
		slTranslate(pos2.X, pos2.Y, pos2.Z)
		slRotX(ang2.X)
		slRotY(ang2.Y)
		slRotZ(ang2.Z)
		slPutPolygon(PD_CUBE)
	slPopMatrix()
	
	ang2.Y = ang2.Y + DEGtoANG(1.0)
	
	local id,ext,data = Smpc_Peripheral(0)
	if bit.bxor(data, mask) == 0xFFFF then
		SYS_Exit(0)
	end
	slSynch()
end