--/*----------------------------------------------------------------------*/
--/*	Gouraud Shading							*/
--/*----------------------------------------------------------------------*/

local VRAMaddr = SpriteVRAM+0x70000

local ang = {}
local pos = {}

slInitSystem(TV_320x224,NULL,1)
slPrint("Sample program 7.6" , 9, 2)
slPrint("Powered by Saturn Lua Player", 9, 3)

ang.X = DEGtoANG(30.0)
ang.Y = DEGtoANG( 0.0)
ang.Z = DEGtoANG( 0.0)
pos.X = 0.0
pos.Y = 0.0
pos.Z = 200.0

-- Note: GFS_Init() has already been called in the Saturn Lua Player
local len = GFS_Load_name("DATA.BIN", 0, CPU_WRAM_LO, CPU_WRAM_LO_LEN)-- filename case sensitive !!!!
if len == nil or len <= 0 then
	slPrint("Error loading data file!", 9, 3)
end
local PD_CUBE = CPU_WRAM_LO + 0x30
local GRdata  = CPU_WRAM_LO + 0x00

slDMACopy(GRdata, VRAMaddr, 6*4*2)

local mask = bit.bor(PER_DGT_ST, PER_DGT_TA, PER_DGT_TB, PER_DGT_TC)

while true do
	slPushMatrix()
		slTranslate(pos.X, pos.Y, pos.Z)
		slRotX(ang.X)
		slRotY(ang.Y)
		slRotZ(ang.Z)
		slPutPolygon(PD_CUBE)
	slPopMatrix()

	ang.Y = ang.Y + DEGtoANG(1.0)

	local id,ext,data = Smpc_Peripheral(0)
	if bit.bxor(data, mask) == 0xFFFF then
		SYS_Exit(0)
	end
	slSynch()
end
