-- ss_scrol.h
local SIPOSX = -35.0
local SIPOSY = -50.0
local POSX_UP = 2.0

local NBG1_CEL_ADR =   VDP2_VRAM_B1
local NBG1_MAP_ADR = ( VDP2_VRAM_B1 + 0x18000 )
local NBG1_COL_ADR =   VDP2_COLRAM
local BACK_COL_ADR = ( VDP2_VRAM_A1 + 0x1fffe )

local ascii_posx = SIPOSX
local ascii_posy = SIPOSY

slInitSystem(TV_320x224,NULL,1)

-- Note: GFS_Init() has already been called in the Saturn Lua Player
local succ, buf, len = pcall(GFS_Load_name_buffer, "DATA.BIN", 0)-- case sensitive !!!!
if not succ or buf == nil or len == nil or len <= 0 then
	slPrint("Error loading ASCII map!", 9, 3)
end

slTVOff()

slPrint("Sample program 8.10.1" , 9, 2) -- note: slLocate(x,y) is not required in Lua, it's faster to just write x,y
slPrint("Powered by Saturn Lua Player", 9, 3)

slColRAMMode(CRM16_1024)
slBack1ColSet(BACK_COL_ADR, 0)

slCharNbg1(COL_TYPE_256 , CHAR_SIZE_1x1)
slPageNbg1(NBG1_CEL_ADR , 0 , bit.bor(PNB_1WORD, CN_10BIT))

slPlaneNbg1(PL_SIZE_1x1)
slMapNbg1(NBG1_MAP_ADR , NBG1_MAP_ADR , NBG1_MAP_ADR , NBG1_MAP_ADR)

Map2VRAM(buf , NBG1_MAP_ADR , 32 , 4 , 0 , 0)
buf = nil -- for garbage collector to free memory

slScrAutoDisp(bit.bor(NBG0ON, NBG1ON))
slTVOn()

local mask = bit.bor(PER_DGT_ST, PER_DGT_TA, PER_DGT_TB, PER_DGT_TC)

while true do
	slScrPosNbg1(ascii_posx , ascii_posy)
	ascii_posx = ascii_posx + POSX_UP
	
	local id,ext,data = Smpc_Peripheral(0)
	if bit.bxor(data, mask) == 0xFFFF then
		SYS_Exit(0)
	end
	slSynch()
end 
