#include <stdlib.h>
#include "alloc.h"

#ifdef USE_BGET
#	include <RB_CartRAM.h>
#endif

void init_ALLOC()
{
    // init memory allocation lib: BGET
#ifdef USE_BGET
// !!! Change: this needs to be user-setable in Saturn Lua Player
				//        // VRAM is last portion (SGL/DOCS/MEMORY.TXT)
				        // not cache-through
				        // 466.232 Bytes
				//    bpool(0x5C0E1C0, 0x5C7FEF8-0x5C0E1C0);
				        // cartridge RAM, be quiet
//				    Sint16 CartID = RB_CartRAM_init(0, 1);
//				    if(CartID == CARTRAM_ID_32M) {
//				        // one continuous bank of cart RAM
//				        bpool(CartRAM0, CartRAMsize << 1);
//				    } else if(CartID == CARTRAM_ID_8M) {
//				        // two seperate, non-continuious cart RAM banks
//				        bpool(CartRAM0, CartRAMsize);
//				        bpool(CartRAM1, CartRAMsize);
//				    }
//				        // low work RAM
//				    bpool(LOW_MEM_START, LOW_MEM_SIZE);

#if 1// fixes sprite display prob
        // free portion of high work RAM up to SGL variable space (SGL/DOCS/MEMORY.TXT)
//    bpool((Uint32)(&_bend), 0x060E0000 - ((Uint32)(&_bend)));
		// just in case standard mem alloc functions are still used somewhere: memory not assigned twice
//	int size = 0x060E0000 - ((Uint32)(&_bend));
	int size = ((Uint32)SortList) - ((Uint32)(&_bend)) - 32*1024;// keep a small amount of memory reserved for unknown malloc calls of libc, otherwise stuff can be overwritten
	unsigned int *ptr = (void *)malloc(size);
	if (ptr != NULL) {
		bpool(ptr, size);
//		slPrint("malloc size", slLocate(5, 15));
//		slPrintHex(size, slLocate(25, 15));
	} else {
//		slPrint("malloc error", slLocate(5, 15));
//		while (1) slSynch();
	}
#endif
#endif    
}




#ifdef DEBUG_BGET
#include <RB_were_here.h>
void waitRelease(Uint16 buttons)
{
    Uint16 data, pull;
    // wait release
    do {
        slSynch();
        data = Smpc_Peripheral[0].data;
        pull = Smpc_Peripheral[0].pull;
    } while( ((data & buttons) != buttons) && ((pull & buttons) != buttons));
//    } while(((data & PER_DGT_ST) == 0) || ((data & PER_DGT_TA) == 0) || ((data & PER_DGT_TB) == 0) || ((data & PER_DGT_TC) == 0));
}

void *dbg_bget(bufsize size)
{
    void *ptr = bget(size);
    waitRelease(PER_DGT_ST | PER_DGT_TA);
    were_here("bget: addr %x, size %i", ptr, size);
    return ptr;
}
void *dbg_bgetz(bufsize size)	
{
    void *ptr = bgetz(size);
    waitRelease(PER_DGT_ST | PER_DGT_TA);
    were_here("bgetz: addr %x, size %i", ptr, size);
    return ptr;
}
void *dbg_bgetr(void *buffer, bufsize newsize)
{
    void *ptr = bgetr(buffer, newsize);
    waitRelease(PER_DGT_ST | PER_DGT_TA);
    were_here("bgetr: addr2 %x,size2 %i", ptr, newsize);
    return ptr;
}
void dbg_brel(void *buf)
{
    brel(buf);
    waitRelease(PER_DGT_ST | PER_DGT_TA);
    were_here("brel: addr %x", buf);
}
#endif // DEBUG_BGET
