//                                                                                
//    Copyright (c) 2006 Thomas Fuchs / The Rockin'-B, www.rockin-b.de       
//                                                                                
//    Permission is granted to anyone to use this software for any purpose        
//    and to redistribute it freely, subject to the following restrictions:       
//                                                                                
//    1.  The origin of this software must not be misrepresented. You must not    
//        claim that you wrote the original software. If you use this software    
//        in a product, an acknowledgment in the product documentation would be   
//        appreciated but is not required.                                        
//                                                                                
//    2.  ANY COMMERCIAL USE IS PROHIBITED. This includes that you must not use   
//        this software in the production of a commercial product. Only an explicit
//        permission by the author can allow you to do that.                      
//                                                                                
//    3.  Any modification applied to the software must be marked as such clearly.
//                                                                                
//    4.  This license may not be removed or altered from any distribution.       
//                                                                                
//                                                                                
//    			    NO WARRANTY                                                 
//                                                                                
//    THERE IS NO WARRANTY FOR THE PROGRAM.                                       
//    THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,               
//    EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,                 
//    THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE.                 
//    THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
//    SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY    
//    SERVICING, REPAIR OR CORRECTION.                                            
//                                                                                
//    IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES,         
//    INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
//    OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED   
//    TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY    
//    YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER  
//    PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE       
//    POSSIBILITY OF SUCH DAMAGES.                                                
//                                                                                

#ifndef HAVE_ALLOC_H
#define HAVE_ALLOC_H

#define USE_BGET
//#define DEBUG_BGET

#ifdef USE_BGET
#	include <bget.h>
#	define LOW_MEM_USED        (0)
#	define LOW_MEM_START       (0x200000 + LOW_MEM_USED)
#	define LOW_MEM_SIZE        (0x100000 - LOW_MEM_USED)
	extern unsigned int _bend;		// end of cleared variables
	extern const void*   SortList;	// start of workarea
#	ifdef DEBUG_BGET
		extern void *dbg_bget(bufsize size);
		extern void *dbg_bgetz(bufsize size);
		extern void *dbg_bgetr(void *buffer, bufsize newsize);
		extern void  dbg_brel(void *buf);
#		define my_malloc(sz)          dbg_bget(sz)
#		define my_calloc(sz, n)       dbg_bgetz(sz*n)
#		define my_realloc(b, sz)      dbg_bgetr(b, sz)
#		define my_free(b)             dbg_brel(b)
#	else
#		define my_malloc(sz)          bget(sz)
#		define my_calloc(sz, n)       bgetz(sz*n)
#		define my_realloc(b, sz)      bgetr(b, sz)
#		define my_free(b)             brel(b)
#	endif//DEBUG_BGET
#else// use default malloc
#	include <stdlib.h>
#	define my_malloc(sz)          malloc(sz)
#	define my_calloc(sz, n)       calloc(sz*n)
#	define my_realloc(b, sz)      realloc(b, sz)
#	define my_free(b)             free(b)
#endif//USE_BGET

void init_ALLOC();

#endif //HAVE_ALLOC_H
