#ifndef _HAVE_API_DEF_IMPLEMENTATION_
#define _HAVE_API_DEF_IMPLEMENTATION_

#include "lua.h"
#include "lauxlib.h"

//#define	fromFIXED(fx)		((LUA_NUMBER)(fx) / 65536.0)
#define	fromFIXED(fx)		((float)(fx) / 65536.0)// a bit smaller binary

#include <SL_DEF.H>

// complete: SL_DEF.H
#define I_INT_O_FX(n, tin1)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==1 /* && lua_isnumber(L, 1)*/ ) {\
			lua_pushnumber(L, fromFIXED(n((tin1)lua_tointeger(L, 1)) ) );\
			return 1;\
		}\
		return 0;\
	}
#define I_AN_O_FX(n)		I_INT_O_FX(n, ANGLE)


#define I_INT_O_V(n, tin)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==1 /*&& lua_isnumber(L, 1)*/ ) {\
			n( (tin)lua_tointeger(L, 1) );\
		}\
		return 0;\
	}
// complete: SL_DEF.H
#define I_AN_O_V(n)			I_INT_O_V(n, ANGLE)
// complete: SL_DEF.H
#define I_U8_O_V(n)			I_INT_O_V(n, Uint8)
// complete: SL_DEF.H
#define I_U16_O_V(n)		I_INT_O_V(n, Uint16)
// complete: SL_DEF.H
#define I_U32_O_V(n)		I_INT_O_V(n, Uint32)
// complete: SL_DEF.H
#define I_S32_O_V(n)		I_INT_O_V(n, Sint32)
// complete: SL_DEF.H
#define I_S8_O_V(n)			I_INT_O_V(n, Sint8)

#define I_INT_O_INT(n, tin)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==1 /*&& lua_isnumber(L, 1)*/ ) {\
			lua_pushinteger(L, n( (tin)lua_tointeger(L, 1)) );\
			return 1;\
		}\
		return 0;\
	}
// complete: SL_DEF.H
#define I_U32_O_U32(n)		I_INT_O_INT(n, Uint32)

#define I_U32_O_S32(n)		I_INT_O_INT(n, Uint32)

#define I_S32_O_S32(n)		I_INT_O_INT(n, Sint32)
// complete: SL_DEF.H
#define I_AN_O_U16(n)		I_INT_O_INT(n, ANGLE)
// complete: SL_DEF.H
#define I_FX_O_V(n)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==1 /*&& lua_isnumber(L, 1)*/ ) {\
			n( toFIXED((float)lua_tonumber(L, 1)) );\
		}\
		return 0;\
	}
	
#define I_FX_O_FX(n)	\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==1 /*&& lua_isnumber(L, 1)*/ ) {\
			lua_pushnumber(L, fromFIXED(n( toFIXED((float)lua_tonumber(L, 1)) ) ) );\
			return 1;\
		}\
		return 0;\
	}

#define I_FX_FX_O_INT(n)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==2 /*&& lua_isnumber(L, 1) && lua_isnumber(L, 2)*/ ) {\
			lua_pushinteger(L, n( toFIXED((float)lua_tonumber(L, 1)), toFIXED((float)lua_tonumber(L, 2)) ) );\
			return 1;\
		}\
		return 0;\
	}
// complete: SL_DEF.H	
#define I_FX_FX_O_AN(n)	I_FX_FX_O_INT(n)
// complete: SL_DEF.H
#define I_FX_FX_O_V(n)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==2 /*&& lua_isnumber(L, 1) && lua_isnumber(L, 2)*/ ) {\
			n(toFIXED((float)lua_tonumber(L, 1)), toFIXED((float)lua_tonumber(L, 2)) );\
		}\
		return 0;\
	}
// complete: SL_DEF.H	
#define I_FX_FX_O_FX(n)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==2 /*&& lua_isnumber(L, 1) && lua_isnumber(L, 2)*/ ) {\
			lua_pushnumber(L, fromFIXED(n( toFIXED((float)lua_tonumber(L, 1)), toFIXED((float)lua_tonumber(L, 2)) ) ) );\
			return 1;\
		}\
		return 0;\
	}

#define I_FX_FX_FX_O_V(n)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==3 /*&& lua_isnumber(L, 1) && lua_isnumber(L, 2) && lua_isnumber(L, 3)*/ ) {\
			n(toFIXED((float)lua_tonumber(L, 1)), toFIXED((float)lua_tonumber(L, 2)), toFIXED((float)lua_tonumber(L, 3)) );\
		}\
		return 0;\
	}

#define I_FX_FX_FX_INT_O_V(n, tin4)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==4 /*&& lua_isnumber(L, 1) && lua_isnumber(L, 2) && lua_isnumber(L, 3) && lua_isnumber(L, 4)*/ ) {\
			n(toFIXED((float)lua_tonumber(L, 1)), toFIXED((float)lua_tonumber(L, 2)), toFIXED((float)lua_tonumber(L, 3)), (tin4)lua_tointeger(L, 4) );\
		}\
		return 0;\
	}

#define I_FX_FX_FX_AN_O_V(n)			I_FX_FX_FX_INT_O_V(n, ANGLE)

#define I_INT_O_B(n,tin)	\
	int lua_##n(lua_State *L) {\
		if (lua_gettop(L)==1 /*&& lua_isnumber(L,1)*/ ) {\
			lua_pushboolean(L, n( (tin)lua_tointeger(L,1) ));\
			return 1;\
		}\
		return 0;\
	}	
// complete: SL_DEF.H
#define I_U8_O_B(n)			I_INT_O_B(n,Uint8)
// complete: SL_DEF.H
#define I_U16_O_B(n)		I_INT_O_B(n,Uint16)
// complete: SL_DEF.H
#define I_U32_O_B(n)		I_INT_O_B(n,Uint32)
// complete: SL_DEF.H
#define I_S16_O_B(n)		I_INT_O_B(n,Sint16)


#define I_INT_INT_O_B(n, tin1, tin2)	\
	int lua_##n(lua_State *L) {\
		if (lua_gettop(L)==2 /*&& lua_isnumber(L,1) && lua_isnumber(L,2)*/ ) {\
			lua_pushboolean(L, n( (tin1)lua_tointeger(L,1), (tin2)lua_tointeger(L,2) ));\
			return 1;\
		}\
		return 0;\
	}

// complete: SL_DEF.H
#define I_U8_U8_O_B(n)		I_INT_INT_O_B(n, Uint8, Uint8)
// complete: SL_DEF.H
#define I_U8_S8_O_B(n)		I_INT_INT_O_B(n, Uint8, Sint8)
// complete: SL_DEF.H
#define I_U8_S16_O_B(n)		I_INT_INT_O_B(n, Uint8, Sint16)


#define I_INT_INT_O_INT(n, tin1, tin2)	\
	int lua_##n(lua_State *L) {\
		if (lua_gettop(L)==2 /*&& lua_isnumber(L,1) && lua_isnumber(L,2)*/ ) {\
			lua_pushinteger(L, n( (tin1)lua_tointeger(L,1), (tin2)lua_tointeger(L,2) ));\
			return 1;\
		}\
		return 0;\
	}

#define I_S32_S32_O_S32(n)		I_INT_INT_O_INT(n, Sint32, Sint32)

#define I_INT_INT_O_V(n, tin1, tin2)	\
	int lua_##n(lua_State *L) {\
		if (lua_gettop(L)==2 /*&& lua_isnumber(L,1) && lua_isnumber(L,2)*/ ) {\
			n( (tin1)lua_tointeger(L,1), (tin2)lua_tointeger(L,2) );\
		}\
		return 0;\
	}
#define I_INT_INT_INT_O_INT(n, tin1, tin2, tin3)	\
	int lua_##n(lua_State *L) {\
		if (lua_gettop(L)==3 /*&& lua_isnumber(L,1) && lua_isnumber(L,2) && lua_isnumber(L,3)*/ ) {\
			lua_pushinteger(L, n( (tin1)lua_tointeger(L,1), (tin2)lua_tointeger(L,2), (tin3)lua_tointeger(L,3) ) );\
			return 1;\
		}\
		return 0;\
	}
#define I_INT_INT_INT_O_V(n, tin1, tin2, tin3)	\
	int lua_##n(lua_State *L) {\
		if (lua_gettop(L)==3 /*&& lua_isnumber(L,1) && lua_isnumber(L,2) && lua_isnumber(L,3)*/ ) {\
			n( (tin1)lua_tointeger(L,1), (tin2)lua_tointeger(L,2), (tin3)lua_tointeger(L,3) );\
		}\
		return 0;\
	}
	
#define I_S16_S16_S16_O_V(n)	I_INT_INT_INT_O_V(n, Sint16, Sint16, Sint16)	
// complete: SL_DEF.H
#define I_S16_S16_O_V(n)		I_INT_INT_O_V(n, Sint16, Sint16)
// complete: SL_DEF.H
#define I_S16_U16_O_V(n)		I_INT_INT_O_V(n, Sint16, Uint16)
// complete: SL_DEF.H
#define I_U16_U16_O_V(n)		I_INT_INT_O_V(n, Uint16, Uint16)

#define I_U16_U16_U16_O_U16(n)	I_INT_INT_INT_O_INT(n, Uint16, Uint16, Uint16)

// complete: SL_DEF.H
#define I_V_O_B(n)	\
	int lua_##n(lua_State *L) {\
		lua_pushboolean(L, n() );\
		return 1;\
	}

#define I_V_O_INT_VAR(n)	\
	int lua_##n(lua_State *L) {\
		lua_pushinteger(L, n);\
		return 1;\
	}

#define I_V_O_INT(n)	\
	int lua_##n(lua_State *L) {\
		lua_pushinteger(L, n() );\
		return 1;\
	}

// complete: SL_DEF.H
#define I_V_O_U8(n)			I_V_O_INT(n)
// complete: SL_DEF.H
#define I_V_O_U16(n)		I_V_O_INT(n)
// complete: SL_DEF.H
#define I_V_O_U32(n)		I_V_O_INT(n)
// complete: SL_DEF.H
#define I_V_O_S8(n)			I_V_O_INT(n)

#define I_V_O_S32(n)		I_V_O_INT(n)

// complete: SL_DEF.H
#define I_V_O_U8_VAR(n)		I_V_O_INT_VAR(n)

#define I_V_O_U16_VAR(n)	I_V_O_INT_VAR(n)
// complete: SL_DEF.H
#define I_V_O_V(n)	\
	int lua_##n(lua_State *L) {\
		n();\
		return 0;\
	}
	
#define I_PTR_O_B(n, tin)	\
	int lua_##n(lua_State *L){\
	    if(lua_gettop(L)==1) {\
		    tin *ptr = lua_isuserdata(L,1) ? (tin *)lua_touserdata(L,1) : (tin *)lua_tointeger(L,1);\
		    if(ptr != NULL) {\
				lua_pushboolean(L, n(ptr) );\
				return 1;\
			}\
		}\
		return 0;\
	}
	//int lua_GFS_NwIsComplete(lua_State *L)
//	{
//		if(lua_gettop(L)==1 && lua_islightuserdata(L, 1)) {
//			lua_pushboolean(L, GFS_NwIsComplete((GfsHn)lua_touserdata(L, 1)));
//			return 1;
//		}
//		return 0;
//	}
	
#define I_PTR_O_V(n, tin, NoNullCheck)	\
	int lua_##n(lua_State *L){\
	    if(lua_gettop(L)==1) {\
	    	tin *ptr = lua_isuserdata(L,1) ? (tin *)lua_touserdata(L,1) : (tin *)lua_tointeger(L,1);\
	    	if(NoNullCheck || ptr != NULL)\
				n(ptr);\
		}\
		return 0;\
	}
//	int lua_sl1MapRA(lua_State *L)
//	{
//		if(lua_gettop(L)==1) {
//			void *adr = lua_isuserdata(L, 1) ? (void *)lua_touserdata(L, 1) : (void *)lua_tointeger(L, 1);
//			sl1MapRA(adr);
//		}
//		return 0;
//	}
#define I_PTR_INT_O_V(n, tin1, tin2)	\
	int lua_##n(lua_State *L){\
	    if(lua_gettop(L)==2 /*&& lua_isnumber(L,2)*/ ) {\
	    	tin1 *ptr = lua_isuserdata(L,1) ? (tin1 *)lua_touserdata(L,1) : (tin1 *)lua_tointeger(L,1);\
	    	if(ptr != NULL)\
				n( ptr, (tin2)lua_tointeger(L,2) );\
		}\
		return 0;\
	}
#define I_PTR_PTR_O_V(n, tin1, tin2)	\
	int lua_##n(lua_State *L){\
	    if(lua_gettop(L)==2) {\
	    	tin1 *p1 = lua_isuserdata(L,1) ? (tin1 *)lua_touserdata(L,1) : (tin1 *)lua_tointeger(L,1);\
	    	tin2 *p2 = lua_isuserdata(L,2) ? (tin2 *)lua_touserdata(L,2) : (tin2 *)lua_tointeger(L,2);\
	    	if(p1 != NULL && p2 != NULL)\
				n( p1, p2 );\
		}\
		return 0;\
	}

#define I_PTR_PTR_INT_O_V(n, tin1, tin2, tin3, NoNullCheck)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==3 /*&& lua_isnumber(L, 3)*/ ) {\
			tin1 *p1 = lua_isuserdata(L, 1) ? (tin1 *)lua_touserdata(L, 1) : (tin1 *)lua_tointeger(L, 1);\
			tin2 *p2 = lua_isuserdata(L, 2) ? (tin2 *)lua_touserdata(L, 2) : (tin2 *)lua_tointeger(L, 2);\
			if( NoNullCheck || (p1 != NULL && p2 != NULL) )\
				n(p1, p2, (tin3)lua_tointeger(L, 3));\
		}\
		return 0;\
	}
		
#define I_VX_VX_U16_O_V(n)		I_PTR_PTR_INT_O_V(n, void, void, Uint16, 1)	// slPageNbgx: null address can occur !!!
#define I_Vx_Vx_U32_O_V(n)		I_PTR_PTR_INT_O_V(n, void, void, Uint32, 0)	
#define I_U8x_Vx_U32_O_V(n)		I_PTR_PTR_INT_O_V(n, Uint8, void, Uint32, 0)	
#define I_U16x_Vx_U32_O_V(n)	I_PTR_PTR_INT_O_V(n, Uint16, void, Uint32, 0)	
	
#define I_PTR_PTR_PTR_PTR_O_V(n, tin1, tin2, tin3, tin4)	\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==4) {\
			tin1 *a = lua_isuserdata(L, 1) ? (tin1 *)lua_touserdata(L, 1) : (tin1 *)lua_tointeger(L, 1);\
			tin2 *b = lua_isuserdata(L, 2) ? (tin2 *)lua_touserdata(L, 2) : (tin2 *)lua_tointeger(L, 2);\
			tin3 *c = lua_isuserdata(L, 3) ? (tin3 *)lua_touserdata(L, 3) : (tin3 *)lua_tointeger(L, 3);\
			tin4 *d = lua_isuserdata(L, 4) ? (tin4 *)lua_touserdata(L, 4) : (tin4 *)lua_tointeger(L, 4);\
			/*if(a != NULL && b != NULL && c != NULL && d != NULL)*/\
			n(a, b, c, d);\
		}\
		return 0;\
	}

#define I_Vx_Vx_Vx_Vx_O_V(n)		I_PTR_PTR_PTR_PTR_O_V(n, void, void, void, void)

#define I_PTR_INT_INT_PTR_O_V(n, tin1, tin2, tin3, tin4)	\
	int lua_##n(lua_State *L){\
	    if(lua_gettop(L)==4 /*&& lua_isnumber(L,2) && lua_isnumber(L,3)*/ ) {\
	    	tin1 *p1 = lua_isuserdata(L,1) ? (tin1 *)lua_touserdata(L,1) : (tin1 *)lua_tointeger(L,1);\
	    	tin4 *p4 = lua_isuserdata(L,4) ? (tin4 *)lua_touserdata(L,4) : (tin4 *)lua_tointeger(L,4);\
	    	/*if(p1 != NULL && p4 != NULL)*/\
				n( p1, (tin2)lua_tointeger(L,2), (tin3)lua_tointeger(L,3), p4 );\
		}\
		return 0;\
	}

#define I_PTR_O_INT(n, tin)	\
	int lua_##n(lua_State *L){\
	    if(lua_gettop(L)==1 && (lua_isnumber(L,1) || lua_isuserdata(L,1)) ) {\
	    	tin *p = lua_isuserdata(L,1) ? (tin *)lua_touserdata(L,1) : (tin *)lua_tointeger(L,1);\
	    	if(p != NULL) {\
				lua_pushinteger(L, n(p) );\
				return 1;\
			}\
		}\
		return 0;\
	}

#define I_PTR_INT_O_INT(n, tin1, tin2)	\
	int lua_##n(lua_State *L){\
	    if(lua_gettop(L)==2 /*&& lua_isnumber(L,2)*/ ) {\
	    	tin1 *p = lua_isuserdata(L,1) ? (tin1 *)lua_touserdata(L,1) : (tin1 *)lua_tointeger(L,1);\
	    	if(p != NULL) {\
				lua_pushinteger(L, n( p, (tin2)lua_tointeger(L,2) ) );\
				return 1;\
			}\
		}\
		return 0;\
	}
//	int lua_GFS_NwCdRead(lua_State *L)
//	{
//		if(lua_gettop(L)==2 && lua_islightuserdata(L, 1) && lua_isnumber(L, 2)) {
//			lua_pushinteger(L, GFS_NwCdRead((GfsHn)lua_touserdata(L, 1), (Sint32)lua_tointeger(L, 2)));
//			return 1;
//		}
//		return 0;
//	}
#define I_PTR_INT_O_B(n, tin1, tin2)	\
	int lua_##n(lua_State *L){\
	    if(lua_gettop(L)==2 /*&& lua_isnumber(L,2)*/ ) {\
	    	tin1 *p = lua_isuserdata(L,1) ? (tin1 *)lua_touserdata(L,1) : (tin1 *)lua_tointeger(L,1);\
	    	if(p != NULL) {\
				lua_pushboolean(L, n( p, (tin2)lua_tointeger(L,2) ) );\
				return 1;\
			}\
		}\
		return 0;\
	}
#define I_INT_STR_O_INT(n, tin1)	\
	int lua_##n(lua_State *L){\
	    if(lua_gettop(L)==2 /*&& lua_isnumber(L,1)*/ && lua_isstring(L,2) ) {\
			lua_pushinteger(L, n( (tin1)lua_tointeger(L,1), lua_tostring(L,2) ) );\
			return 1;\
		}\
		return 0;\
	}
#define I_INT_STR_PTR_O_INT(n, tin1, tin3)	\
	int lua_##n(lua_State *L){\
	    if(lua_gettop(L)==3 /*&& lua_isnumber(L,1)*/ && lua_isstring(L,2) ) {\
	    	tin3 *p = lua_isuserdata(L,3) ? (tin3 *)lua_touserdata(L,3) : (tin3 *)lua_tointeger(L,3);\
	    	if(p != NULL){\
				lua_pushinteger(L, n( (tin1)lua_tointeger(L,1), lua_tostring(L,2), p ) );\
				return 1;\
			}\
		}\
		return 0;\
	}
#define I_U32_STR_O_S32(n)			I_INT_STR_O_INT(n, Uint32)
#define I_U32_STR_U8x_O_S32(n)		I_INT_STR_PTR_O_INT(n, Uint32, Uint8)// not used yet
	
#define I_Vx_S32_O_S32(n)	I_PTR_INT_O_INT(n, void, Sint32)
#define I_Vx_S32_O_V(n)		I_PTR_INT_O_V(n, void, Sint32)
#define I_Vx_U16_O_V(n)		I_PTR_INT_O_V(n, void, Uint16)
#define I_Vx_U16_O_B(n)		I_PTR_INT_O_B(n, void, Uint16)
#define I_Vx_Vx_O_V(n)		I_PTR_PTR_O_V(n, void, void)// not used yet

#define I_Vx_U32_U32_Vx_O_V(n)		I_PTR_INT_INT_PTR_O_V(n, void, Uint32, Uint32, void)

// complete: SL_DEF.H, SEGA_GFS.H
#define I_Vx_O_B(n)			I_PTR_O_B(n, void)
// complete: SL_DEF.H, SEGA_GFS.H
#define I_Vx_O_V(n)			I_PTR_O_V(n, void, 0)
#define I_VX_O_V(n)			I_PTR_O_V(n, void, 1)	// no NULL pointer check for sl***Matrix() functions using CURRENT

#define I_U16x_O_V(n)		I_PTR_O_V(n, Uint16, 0)

// complete: SL_DEF.H, SEGA_GFS.H
#define I_Vx_O_S32(n)		I_PTR_O_INT(n, void)


#define I_INT_O_PTR(n, tin1)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==1 /*&& lua_isnumber(L, 1)*/ ){\
			lua_pushlightuserdata(L, n( (tin1)lua_tointeger(L, 1) ) );\
			return 1;\
		}\
		return 0;\
	}
#define I_INT_INT_INT_O_PTR(n, tin1, tin2, tin3)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==3 /*&& lua_isnumber(L, 1) && lua_isnumber(L, 2) && lua_isnumber(L, 3)*/ ) {\
			lua_pushlightuserdata(L, n( (tin1)lua_tointeger(L, 1), (tin2)lua_tointeger(L, 2), (tin3)lua_tointeger(L, 3)) );\
			return 1;\
		}\
		return 0;\
	}


#define I_S32_O_Vx(n)				I_INT_O_PTR(n, Sint32)
#define I_U16_U16_U16_O_Vx(n)		I_INT_INT_INT_O_PTR(n, Uint16, Uint16, Uint16)

#define I_INT_INT_INT_INT_O_V(n, tin1, tin2, tin3, tin4)	\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==4 /*&& lua_isnumber(L, 1) && lua_isnumber(L, 2) && lua_isnumber(L, 3) && lua_isnumber(L, 4)*/ ) {\
			n((tin1)lua_tointeger(L, 1), (tin2)lua_tointeger(L, 2), (tin3)lua_tointeger(L, 3), (tin4)lua_tointeger(L, 4));\
		}\
		return 0;\
	}
	//int lua_slScrCycleSet(lua_State *L)
//	{
//		if(lua_gettop(L)==4 && lua_isnumber(L, 1) && lua_isnumber(L, 2) && lua_isnumber(L, 3) && lua_isnumber(L, 4)) {
//	// this results in 0x7fffffff for some large numbers:
//	//		slScrCycleSet((Uint32)lua_tointeger(L, 1), (Uint32)lua_tointeger(L, 2), (Uint32)lua_tointeger(L, 3), (Uint32)lua_tointeger(L, 4));
//	// this works, even when lua numbers are restricted to floats, while compiling lua
//		slScrCycleSet((Uint32)((float)lua_tonumber(L, 1)), (Uint32)((float)lua_tonumber(L, 2)), (Uint32)((float)lua_tonumber(L, 3)), (Uint32)((float)lua_tonumber(L, 4)));
//	// works with double numbers in lua		slScrCycleSet((Uint32)((double)lua_tonumber(L, 1)), (Uint32)((double)lua_tonumber(L, 2)), (Uint32)((double)lua_tonumber(L, 3)), (Uint32)((double)lua_tonumber(L, 4)));
//	// works:		slScrCycleSet(0xe55eeeee, 0xe55eeeee, 0x0505eeee, 0x4444eeee);
//		}
//		return 0;
//	}

// complete: SL_DEF.H
#define I_U16_U16_U16_U16_O_V(n)	I_INT_INT_INT_INT_O_V(n, Uint16, Uint16, Uint16, Uint16)
// complete: SL_DEF.H
#define I_S16_S16_S16_S8_O_V(n)		I_INT_INT_INT_INT_O_V(n, Sint16, Sint16, Sint16, Sint8)
// complete: SL_DEF.H
#define I_U32_U32_U32_U32_O_V(n)	I_INT_INT_INT_INT_O_V(n, Uint32, Uint32, Uint32, Uint32)


#define I_INT_INT_INT_INT_O_B(n, tin1, tin2, tin3, tin4)	\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==4 /*&& lua_isnumber(L, 1) && lua_isnumber(L, 2) && lua_isnumber(L, 3) && lua_isnumber(L, 4)*/ ) {\
			lua_pushboolean(L, n((tin1)lua_tointeger(L, 1), (tin2)lua_tointeger(L, 2), (tin3)lua_tointeger(L, 3), (tin4)lua_tointeger(L, 4)) );\
		}\
		return 0;\
	}
#define I_INT_INT_INT_INT_INT_INT_INT_O_B(n, tin1, tin2, tin3, tin4, tin5, tin6, tin7)	\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==7 /*&& lua_isnumber(L, 1) && lua_isnumber(L, 2) && lua_isnumber(L, 3) && lua_isnumber(L, 4) && lua_isnumber(L, 5) && lua_isnumber(L, 6) && lua_isnumber(L, 7)*/ ) {\
			lua_pushboolean(L, n((tin1)lua_tointeger(L, 1), (tin2)lua_tointeger(L, 2), (tin3)lua_tointeger(L, 3), (tin4)lua_tointeger(L, 4), (tin5)lua_tointeger(L, 5), (tin6)lua_tointeger(L, 6), (tin7)lua_tointeger(L, 7)) );\
		}\
		return 0;\
	}
#define I_U16_U8_U8_U8_O_B(n)		I_INT_INT_INT_INT_O_B(n, Uint16, Uint8, Uint8, Uint8)
#define I_U8_U8_S8_S8_O_B(n)		I_INT_INT_INT_INT_O_B(n, Uint8, Uint8, Sint8, Sint8)

#define I_S16_S16_S16_S16_S16_S16_S16_O_B(n)	I_INT_INT_INT_INT_INT_INT_INT_O_B(n, Sint16, Sint16, Sint16, Sint16, Sint16, Sint16, Sint16)


#define I_Vx_S32_Vx_S32_O_S32(n)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==4 && lua_isnumber(L,2) && lua_isnumber(L,4)) {\
			void *p1 = lua_isuserdata(L,1) ? (void *)lua_touserdata(L,1) : (void *)lua_tointeger(L,1);\
			void *p3 = lua_isuserdata(L,3) ? (void *)lua_touserdata(L,3) : (void *)lua_tointeger(L,3);\
			if(p1 != NULL && p3 != NULL) {\
				lua_pushinteger(L, n( p1, (Sint32)lua_tointeger(L,2), p3, (Sint32)lua_tointeger(L,4)));\
				return 1;\
			}\
		}\
		return 0;\
	}

#define I_Vx_S32_S32_O_S32(n)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==3 /*&& lua_isnumber(L,2) && lua_isnumber(L,3)*/ ) {\
			void *p = lua_isuserdata(L,1) ? (void *)lua_touserdata(L,1) : (void *)lua_tointeger(L,1);\
			if(p != NULL){\
				lua_pushinteger(L, n( p, (Sint32)lua_tointeger(L,2), (Sint32)lua_tointeger(L,3)));\
				return 1;\
			}\
		}\
		return 0;\
	}

#define I_VC_VC_VC_O_VC(n)\
	int lua_##n(lua_State *L){\
		if(lua_gettop(L)==3 && lua_istable(L, 1) && lua_istable(L, 2) && lua_istable(L, 3) ) {\
			VECTOR a,b,c,ans;\
			getVECTORfromTable(L, 1, a);\
			getVECTORfromTable(L, 2, b);\
			getVECTORfromTable(L, 3, c);\
			n(a, b, c, ans);\
			setVECTORtoTable(L, ans);\
			return 1;\
		}\
		return 0;\
	}

	
//	Inputs
//		[int pad_index] (0-15)
//	Outputs
		//typedef struct {			/* fW^foCX			*/
//			Uint8	id;			/* ytFhc			*/
//			Uint8	ext;			/* gf[^TCY			*/
//			Uint16	data;			/* {^݃f[^			*/
//			Uint16	push;			/* {^f[^			*/
//			Uint16	pull;			/* {^f[^			*/
//			Uint32	dummy2[4];		/* _~[Q				*/
//		} PerDigital;
//		on error:	none


#define I_U8_O_Smpc_Peripheral(n)	\
	int lua_##n(lua_State *L) {\
		int idx = 0;\
\
		if(lua_gettop(L)==1 /*&& lua_isnumber(L, 1)*/ )\
			idx = (int)lua_tointeger(L, 1);\
\
		if(idx <= 15) {\
			lua_pushinteger(L, Smpc_Peripheral[idx].id);\
			lua_pushinteger(L, Smpc_Peripheral[idx].ext);\
			lua_pushinteger(L, Smpc_Peripheral[idx].data);\
			lua_pushinteger(L, Smpc_Peripheral[idx].push);\
			lua_pushinteger(L, Smpc_Peripheral[idx].pull);\
			lua_pushinteger(L, Smpc_Peripheral[idx].dummy2[0]);\
			lua_pushinteger(L, Smpc_Peripheral[idx].dummy2[1]);\
			lua_pushinteger(L, Smpc_Peripheral[idx].dummy2[2]);\
			lua_pushinteger(L, Smpc_Peripheral[idx].dummy2[3]);\
			return 9;\
		}\
		return 0;\
	}
	
	
//	Inputs
//		none
//	Outputs
//		typedef struct {			/* rlobXe[^X			*/
//			Uint8	cond;			/* ԃXe[^X			*/
//			Uint8	dummy1;			/* _~[P				*/
//			Uint16	dummy2;			/* _~[Q				*/
//			Uint8	ctg;			/* J[gbWR[h			*/
//			Uint8	area;			/* GAR[h				*/
//			Uint16	system;			/* VXeXe[^X			*/
//			Uint32	smem;			/* rlobێf[^		*/
//			SmpcDateTime	rtc;		/* qsb				*/
//				typedef struct {			/* qsb				*/
//					Uint16	year;			/* N				*/
//					Uint8	month;			/* jE				*/
//					Uint8	date;			/* 					*/
//					Uint8	hour;			/* 					*/
//					Uint8	minute;			/* 					*/
//					Uint8	second;			/* b					*/
//					Uint8	dummy;			/* _~[				*/
//				} SmpcDateTime;
//		} SmpcStatus;
#define I_V_O_Smpc_Status(n)	\
	int lua_##n(lua_State *L){\
		lua_pushinteger(L, Smpc_Status->cond);\
		lua_pushinteger(L, Smpc_Status->dummy1);\
		lua_pushinteger(L, Smpc_Status->dummy2);\
		lua_pushinteger(L, Smpc_Status->ctg);\
		lua_pushinteger(L, Smpc_Status->area);\
		lua_pushinteger(L, Smpc_Status->system);\
		lua_pushinteger(L, Smpc_Status->smem);\
	\
		lua_pushinteger(L, Smpc_Status->rtc.year);\
		lua_pushinteger(L, Smpc_Status->rtc.month);\
		lua_pushinteger(L, Smpc_Status->rtc.date);\
		lua_pushinteger(L, Smpc_Status->rtc.hour);\
		lua_pushinteger(L, Smpc_Status->rtc.minute);\
		lua_pushinteger(L, Smpc_Status->rtc.second);\
		lua_pushinteger(L, Smpc_Status->rtc.dummy);\
		return 14;\
	}
	
	
	
	
	
#endif //_HAVE_API_DEF_IMPLEMENTATION_
