//#ifndef _HAVE_API_DEF_REGISTER_
//#define _HAVE_API_DEF_REGISTER_

#include "lua.h"
#include "lauxlib.h"


#define TEMPLATE_DECLARATION(n)		extern int lua_##n(lua_State *L)
#define TEMPLATE_REGISTER(n)		lua_register(L, #n, lua_##n )

#ifdef TEMPLATE
#	undef TEMPLATE
#endif

#ifdef API_DO_REGISTER
#		define TEMPLATE(n)			TEMPLATE_REGISTER(n)
#else
#	ifdef API_DO_DECLARATION
#		define TEMPLATE(n)			TEMPLATE_DECLARATION(n)
#	endif
#endif
#undef API_DO_REGISTER
#undef API_DO_DECLARATION





#define I_AN_O_FX(n)			TEMPLATE(n)
#define I_AN_O_V(n)				TEMPLATE(n)
#define I_U8_O_V(n)				TEMPLATE(n)
#define I_U16_O_V(n)			TEMPLATE(n)
#define I_U32_O_V(n)			TEMPLATE(n)
#define I_S32_O_V(n)			TEMPLATE(n)
#define I_S8_O_V(n)				TEMPLATE(n)

#define I_U32_O_U32(n)			TEMPLATE(n)
#define I_U32_O_S32(n)			TEMPLATE(n)
#define I_S32_O_S32(n)			TEMPLATE(n)
#define I_AN_O_U16(n)			TEMPLATE(n)
#define I_FX_O_V(n)				TEMPLATE(n)
#define I_FX_O_FX(n)			TEMPLATE(n)
#define I_FX_FX_O_AN(n)			TEMPLATE(n)
#define I_FX_FX_O_V(n)			TEMPLATE(n)
#define I_FX_FX_FX_O_V(n)		TEMPLATE(n)
#define I_FX_FX_FX_AN_O_V(n)	TEMPLATE(n)
#define I_FX_FX_O_FX(n)			TEMPLATE(n)

#define I_U8_O_B(n)				TEMPLATE(n)
#define I_U16_O_B(n)			TEMPLATE(n)
#define I_U32_O_B(n)			TEMPLATE(n)
#define I_S16_O_B(n)			TEMPLATE(n)
#define I_U8_U8_O_B(n)			TEMPLATE(n)
#define I_U8_S8_O_B(n)			TEMPLATE(n)
#define I_U8_S16_O_B(n)			TEMPLATE(n)

#define I_S32_S32_O_S32(n)		TEMPLATE(n)

#define I_V_O_B(n)				TEMPLATE(n)

#define I_V_O_U8(n)				TEMPLATE(n)
#define I_V_O_U8_VAR(n)			TEMPLATE(n)
#define I_V_O_U16_VAR(n)		TEMPLATE(n)
#define I_V_O_U16(n)			TEMPLATE(n)
#define I_V_O_U32(n)			TEMPLATE(n)
#define I_V_O_S8(n)				TEMPLATE(n)
#define I_V_O_S32(n)			TEMPLATE(n)

#define I_V_O_V(n)				TEMPLATE(n)

#define I_S16_S16_O_V(n)		TEMPLATE(n)
#define I_S16_U16_O_V(n)		TEMPLATE(n)
#define I_U16_U16_O_V(n)		TEMPLATE(n)
#define I_U16_U16_U16_O_U16(n)	TEMPLATE(n)
#define I_S16_S16_S16_O_V(n)	TEMPLATE(n)

#define I_Vx_S32_O_S32(n)		TEMPLATE(n)
#define I_Vx_S32_O_V(n)			TEMPLATE(n)
#define I_Vx_U16_O_V(n)			TEMPLATE(n)
#define I_Vx_U16_O_B(n)			TEMPLATE(n)
#define I_Vx_Vx_O_V(n)			TEMPLATE(n)
#define I_Vx_O_B(n)				TEMPLATE(n)
#define I_Vx_O_V(n)				TEMPLATE(n)
#define I_VX_O_V(n)				TEMPLATE(n)
#define I_VX_VX_U16_O_V(n)		TEMPLATE(n)
#define I_Vx_Vx_U32_O_V(n)		TEMPLATE(n)
#define I_U8x_Vx_U32_O_V(n)		TEMPLATE(n)
#define I_U16x_Vx_U32_O_V(n)	TEMPLATE(n)
#define I_Vx_Vx_Vx_Vx_O_V(n)	TEMPLATE(n)
#define I_U16x_O_V(n)			TEMPLATE(n)
#define I_Vx_O_S32(n)			TEMPLATE(n)

#define I_S32_O_Vx(n)				TEMPLATE(n)
#define I_U16_U16_U16_O_Vx(n)		TEMPLATE(n)
#define I_U16_U16_U16_U16_O_V(n)	TEMPLATE(n)
#define I_S16_S16_S16_S8_O_V(n)		TEMPLATE(n)
#define I_U32_U32_U32_U32_O_V(n)	TEMPLATE(n)
#define I_Vx_U32_U32_Vx_O_V(n)		TEMPLATE(n)

#define I_U16_U8_U8_U8_O_B(n)		TEMPLATE(n)
#define I_U8_U8_S8_S8_O_B(n)		TEMPLATE(n)

#define I_S16_S16_S16_S16_S16_S16_S16_O_B(n)	TEMPLATE(n)

#define I_Vx_S32_Vx_S32_O_S32(n)	TEMPLATE(n)
#define I_Vx_S32_S32_O_S32(n)		TEMPLATE(n)

#define I_U32_STR_O_S32(n)			TEMPLATE(n)
#define I_U32_STR_U8x_O_S32(n)		TEMPLATE(n)

#define I_VC_VC_VC_O_VC(n)			TEMPLATE(n)

// special treatment
#define I_U8_O_Smpc_Peripheral(n)	TEMPLATE(n)
#define I_V_O_Smpc_Status(n)		TEMPLATE(n)

//#endif // _HAVE_API_DEF_REGISTER_
