#include "lua.h"
#include <SL_DEF.H>

void setfield_Integer(lua_State *L, unsigned int v, const char *k)
{
#if 0
	// doesn't work...
	lua_pushinteger(L, v);
	lua_setfield (L, -2, "I");
#else
	lua_pushstring(L, k);
	lua_pushinteger(L, v);
	lua_settable (L, -3);
#endif
}

void setfield_Number(lua_State *L, float v, const char *k)
{
	lua_pushstring(L, k);
	lua_pushnumber(L, v);
	lua_settable (L, -3);
}


char *getfield_lString(lua_State *L, int idx, char *key, size_t *len)
{
	char *ret;
	lua_pushstring(L, "X");
	lua_gettable(L, idx);
	ret = (char *)lua_tolstring(L, -1, len);
	lua_pop(L, 1);
	return ret;
}

int getfield_Integer(lua_State *L, int idx, char *key)
{
	int ret;
	lua_pushstring(L, "X");
	lua_gettable(L, idx);
	ret = lua_tointeger(L, -1);
	lua_pop(L, 1);
	return ret;
}

void getVECTORfromTable(lua_State *L, int idx, FIXED *vct)
{
	lua_pushstring(L, "X");
	lua_gettable(L, idx);
	vct[X] = toFIXED((float)lua_tonumber(L, -1));
	lua_pop(L, 1);
	
	lua_pushstring(L, "Y");
	lua_gettable(L, idx);
	vct[Y] = toFIXED((float)lua_tonumber(L, -1));
	lua_pop(L, 1);
	
	lua_pushstring(L, "Z");
	lua_gettable(L, idx);
	vct[Z] = toFIXED((float)lua_tonumber(L, -1));
	lua_pop(L, 1);
}

void setVECTORtoTable(lua_State *L, FIXED *vct)
{
	lua_createtable (L, 0, 3);
	setfield_Number(L, (float)vct[X] / 65536.0, "X");
	setfield_Number(L, (float)vct[Y] / 65536.0, "Y");
	setfield_Number(L, (float)vct[Z] / 65536.0, "Z");
}

#define API_DO_IMPLEMENTATION
#include "api_def_implementation.h"
#include "api.h"
