#include <string.h>
#include "lua.h"
#include "lauxlib.h"

#include	"sgl.h"

extern void setfield_Integer(lua_State *L, unsigned int v, const char *k);

void Cel2VRAM( Uint8 *Cel_Data , void *Cell_Adr , Uint32 suu )
{
	Uint32 i;
	Uint8 *VRAM;

	VRAM = (Uint8 *)Cell_Adr;

	for( i = 0; i < suu; i++ )
		*(VRAM++) = *(Cel_Data++);
}


void Map2VRAM( Uint16 *Map_Data , void *Map_Adr , Uint16 suuj , Uint16 suui , Uint16 palnum ,Uint32 mapoff)
{
	Uint16 i , j;
	Uint16 paloff;
	Uint16 *VRAM;

	paloff= palnum << 12;
	VRAM = (Uint16 *)Map_Adr;
	

	for( i = 0; i < suui; i++ ) {
		for( j = 0; j < suuj; j++ ) {
			*VRAM++ = (*Map_Data | paloff) + mapoff;
			Map_Data++;
		}
		VRAM += (64 - suuj);
	}
}


void Pal2CRAM( Uint16 *Pal_Data , void *Col_Adr , Uint32 suu )
{
	Uint16 i;
	Uint16 *VRAM;

	VRAM = (Uint16 *)Col_Adr;

	for( i = 0; i < suu; i++ )
		*(VRAM++) = *(Pal_Data++);
}


//	Inputs
//		Uint16 *Map_Data , void *Map_Adr , Uint16 suuj , Uint16 suui , Uint16 palnum ,Uint32 mapoff
//	Outputs
//		none

static int lua_Map2VRAM(lua_State *L)
{
//	if(lua_gettop(L)==6 && (lua_isuserdata(L, 1) || lua_isnumber(L, 1)) && (lua_isuserdata(L, 2) || lua_isnumber(L, 2)) && lua_isnumber(L, 3) && lua_isnumber(L, 4) && lua_isnumber(L, 5) && lua_isnumber(L, 6)) {
		Uint16 *Map_Data = lua_isuserdata(L, 1) ? (Uint16 *)lua_touserdata(L, 1) : (Uint16 *)lua_tointeger(L, 1);
		void   *Map_Adr  = lua_isuserdata(L, 2) ? (void   *)lua_touserdata(L, 2) : (void   *)lua_tointeger(L, 2);
		if(Map_Data != NULL && Map_Adr != NULL)
	    	Map2VRAM(Map_Data, Map_Adr, (Uint16)lua_tointeger(L, 3), (Uint16)lua_tointeger(L, 4), (Uint16)lua_tointeger(L, 5), (Uint32)lua_tointeger(L, 6));
//	}
	return 0;
}



void set_texture(TEXTURE *txtbl, PICTURE *pcptr, Uint32 NbPicture)
{
	TEXTURE *txptr;
	 
	for(; NbPicture-- > 0; pcptr++){
		txptr = txtbl + pcptr->texno;
		slDMACopy((void *)pcptr->pcsrc,
			(void *)(SpriteVRAM + ((txptr->CGadr) << 3)),
			(Uint32)((txptr->Hsize * txptr->Vsize * 4) >> (pcptr->cmode)));
	}
}



//	Inputs
//		Sint32 bsize
//	Outputs
//		on success:	void *buffer
//		on error:	none

static int lua_getnewuserdata(lua_State *L)
{
	if(lua_gettop(L)==1 && lua_isnumber(L, 1)) {
		if (lua_newuserdata(L, lua_tointeger(L, 1)) != NULL)
			return 1;
	}
	return 0;
}



//	Inputs
//		user data
//	Outputs
//		integer pointer location

static int lua_getintegerlocation(lua_State *L)
{
	if(lua_gettop(L)==1 /*&& (lua_isnumber(L, 1) || lua_isuserdata(L, 1))*/ ) {
		if (lua_isuserdata(L, 1))
			lua_pushinteger(L, (Uint32)(void *)lua_touserdata(L, 1));
		else if (lua_isnumber(L, 1))
			lua_pushinteger(L, lua_tointeger(L, 1));
		return 1;
	}
	return 0;
}

//	Inputs
//		user data / integer
//	Outputs
//		integer pointer location

static int lua_getlongat(lua_State *L)
{
	if(lua_gettop(L)==1 /*&& (lua_isnumber(L, 1) || lua_isuserdata(L, 1))*/ ) {
		Uint32 *ptr = lua_isuserdata(L, 1) ? (Uint32 *)lua_touserdata(L, 1) : (Uint32 *)lua_tointeger(L, 1);
		lua_pushinteger(L, *ptr );
		return 1;
	}
	return 0;
}
static int lua_getshortat(lua_State *L)
{
	if(lua_gettop(L)==1 /*&& (lua_isnumber(L, 1) || lua_isuserdata(L, 1))*/ ) {
		Uint16 *ptr = lua_isuserdata(L, 1) ? (Uint16 *)lua_touserdata(L, 1) : (Uint16 *)lua_tointeger(L, 1);
		lua_pushinteger(L, *ptr );
		return 1;
	}
	return 0;
}

#include <RB_CartRAM.h>

//	Inputs
//		none
//	Outputs
//		CartID, CartRam0, CartRam0Size [, CartRam1, CartRam1Size]

static int lua_RB_CartRAM_init(lua_State *L)
{
        // cartridge RAM, be quiet
    Sint16 CartID = RB_CartRAM_init(0, 1);
    lua_pushinteger(      L, CartID);
    if(CartID == CARTRAM_ID_32M) {
        // one continuous bank of cart RAM
        lua_pushlightuserdata(L, CartRAM0);
        lua_pushinteger(      L, CartRAMsize << 1);
        return 3;
    } else if(CartID == CARTRAM_ID_8M) {
        // two seperate, non-continuous cart RAM banks
        lua_pushlightuserdata(L, CartRAM0);
        lua_pushinteger(      L, CartRAMsize);
        lua_pushlightuserdata(L, CartRAM1);
        lua_pushinteger(      L, CartRAMsize);
        return 5;
    }
    return 0;
}

#include "vblank.h"

//	Inputs
//		Lua function name
//	Outputs
//		-1 on fail, positive index on sucess

static int lua_vblk_func_add(lua_State *L)
{
	if(lua_gettop(L)==1 && lua_isfunction(L, 1) ) {
//		lua_getglobal (L, const char *name); /* function to be called */
		vblk_func f = (vblk_func)lua_tocfunction(L, 1);		
		lua_pushinteger(L, vblk_func_add(f) );
		lua_pushinteger(L, (Uint32)f);// for debugging
		return 2;
	}
	return 0;
}

//	Inputs
//		Lua function name
//	Outputs
//		-1 on fail, positive index on sucess

static int lua_vblk_func_remove(lua_State *L)
{
	if(lua_gettop(L)==1 && lua_isfunction(L, 1) ) {
//		lua_getglobal (L, const char *name); /* function to be called */
		vblk_func f = (vblk_func)lua_tocfunction(L, 1);		
		lua_pushinteger(L, vblk_func_remove(f) );
		return 1;
	}
	return 0;
}

// taken from SGL/SAMPLE/SBKLIB/sample2.c
#include <SEGA_BUP.H>
#define		BUP_START_ADDR	0x6070000

Sint32	BackUpDelete(Uint32 device,Uint8 *filename)
{
	Sint32	ret;

	slResetDisable();
	ret = BUP_Delete(device, filename);
	slResetEnable();

	return(ret);
}


Sint32	BackUpFormat(Uint32 device)
{
	Sint32	ret;

	slResetDisable();
	ret = BUP_Format(device);
	slResetEnable();

	return(ret);
}


void	BackUpInit(Uint32 *BackUpRamWork, BupConfig cntb[3] )
{
//	Uint32	BackUpRamWork[2048];// MUST be global for the time using the BUP

	slResetDisable();
	BUP_Init((Uint32 *)BUP_START_ADDR,BackUpRamWork,cntb);
	slResetEnable();
}

//	Inputs
//		none
//	Outputs
//		BackUpRamWork, BupConfig tbl

#define BupConfig_NUM		3
static int lua_BackUpInit(lua_State *L)
{
	int i;
	BupConfig cntb[BupConfig_NUM];//       = (BupConfig *)lua_newuserdata(L, BupConfig_NUM*sizeof(BupConfig) );
	Uint32 *BackUpRamWork = (Uint32 *)   lua_newuserdata(L, 2048*sizeof(Uint32) );
	if (BackUpRamWork == NULL) return 0;
	
	BackUpInit(BackUpRamWork, cntb);

	lua_createtable(L, BupConfig_NUM, 0);
	
	for(i=0; i<BupConfig_NUM; i++) {
		lua_pushinteger(L, i+1);	// key
		lua_createtable(L, 0, 2);	// value
		setfield_Integer(L, cntb[i].unit_id  , "unit_id");
		setfield_Integer(L, cntb[i].partition, "partition");
		lua_settable(L, -3);
	}
	return 2;
}

//	Inputs
//		device, size
//	Outputs
//		status, BupStat structure

static int lua_BUP_Stat(lua_State *L)
{
	if (lua_gettop(L)==2 /*&& lua_isnumber(L,1) && lua_isnumber(L,2)*/ ){
    	BupStat	sttb;
    	Sint32 status = BUP_Stat( (Uint32)lua_tointeger(L,1), (Uint32)lua_tointeger(L,2), &sttb );
    	lua_pushinteger(L, status);
    	
    	lua_createtable (L, 0, 6);
    	setfield_Integer(L, sttb.totalsize , "totalsize");
    	setfield_Integer(L, sttb.totalblock, "totalblock");
    	setfield_Integer(L, sttb.blocksize , "blocksize");
    	setfield_Integer(L, sttb.freesize  , "freesize");
    	setfield_Integer(L, sttb.freeblock , "freeblock");
    	setfield_Integer(L, sttb.datanum   , "datanum");
		return 2;
	}
	return 0;
}

Sint32	BackUpWrite(Uint32 device, BupDir *dir, Uint8 *data, Uint8 sw)
{
	Sint32		ret;
	SmpcDateTime	*time;
	BupDate		date;
	
	if(!dir->date){
		time = &(Smpc_Status->rtc);
		date.year  = (Uint8 )( slDec2Hex((Uint32)time->year)-1980 ); /* Modify K.T */
		date.month = (Uint8 )( time->month & 0x0f);
		date.week  = (Uint8 )( time->month >> 4  );
		date.day   = (Uint8 )( slDec2Hex((Uint32)time->date));   /* Modify K.T */
		date.time  = (Uint8 )( slDec2Hex((Uint32)time->hour));   /* Modify K.T */
		date.min   = (Uint8 )( slDec2Hex((Uint32)time->minute)); /* Modify K.T */
		dir->date = BUP_SetDate(&date);
	}
	slResetDisable();
	ret = BUP_Write(device,dir,data,sw);
	slResetEnable();

	return(ret);
}

//	Inputs
//		device, filename, comment, language, data, size, sw
//	Outputs
//		status

//static int lua_BackUpWrite(lua_State *L)
//{
//	if (lua_gettop(L)==7 && lua_isnumber(L,1) && lua_isstring(L,2) && lua_isstring(L,3) && lua_isnumber(L,4) && (lua_isstring(L,5) || lua_isnumber(L,5) || lua_isuserdata(L,5)) && lua_isnumber(L,6) && lua_isnumber(L,7) ){
//		Uint8 *data = lua_isuserdata(L,5) ? (Uint8 *)lua_touserdata(L,5) : (lua_isstring(L,5) ? (Uint8 *)lua_tostring(L,5) : (Uint8 *)lua_tointeger(L,5) );
//		BupDir dir;
////		strncpy( (char *)dir.filename, lua_tostring(L, 2), strlen(lua_tostring(L, 2)) <= 11 ? : strlen(lua_tostring(L, 2)) );
////		strncpy( (char *)dir.comment , lua_tostring(L, 3), strlen(lua_tostring(L, 3)) <= 10 ? : strlen(lua_tostring(L, 3)) );
//		size_t fl = 0, cl = 0;
//		char *filename = (char *)lua_tolstring(L, 2, &fl);
//		char *comment  = (char *)lua_tolstring(L, 3, &cl);
//		if (fl > 12) fl = 12;
//		if (cl > 11) cl = 11;
//		strncpy( (char *)dir.filename, filename, fl );
//		strncpy( (char *)dir.comment , comment , cl );
//		dir.filename[11] = '\0';
//		dir.comment[10]  = '\0';
//		dir.language = (Uint8 )lua_tointeger(L,4);
//		dir.datasize = (Uint32)lua_tointeger(L,6);
//		dir.date     = 0;
//		lua_pushinteger(L, BackUpWrite((Uint32)lua_tointeger(L,1), &dir, data, (Uint8)lua_tointeger(L,7)) );
//		return 1;
//	}
//	return 0;
//}

//	Inputs
//		device, dir, data, sw
//	Outputs
//		status

extern char *getfield_lString(lua_State *L, int idx, char *key, size_t *len);
extern int   getfield_Integer(lua_State *L, int idx, char *key);

static int lua_BackUpWrite(lua_State *L)
{
	if (lua_gettop(L)==4 /*&& lua_isnumber(L,1)*/ && lua_istable(L,2) /*&& lua_isnumber(L,4)*/ ) {
		Uint8 *data = lua_isuserdata(L,3) ? (Uint8 *)lua_touserdata(L,3) : (lua_isstring(L,3) ? (Uint8 *)lua_tostring(L,3) : (Uint8 *)lua_tointeger(L,3) );
		if(data != NULL) {
			BupDir dir;
			size_t fl = 0, cl = 0;
			char *filename = getfield_lString(L, 2, "filename", &fl);
			char *comment  = getfield_lString(L, 2, "comment", &cl);
			if (fl > 12) fl = 12;
			if (cl > 11) cl = 11;
			strncpy( (char *)dir.filename, filename, fl );
			strncpy( (char *)dir.comment , comment , cl );
			dir.filename[11] = '\0';
			dir.comment[10]  = '\0';
			
			dir.language  = (Uint8 )getfield_Integer(L, 2, "language");
			dir.date      = 0;
			dir.datasize  = (Uint32)getfield_Integer(L, 2, "datasize");
			dir.blocksize = (Uint32)getfield_Integer(L, 2, "blocksize");
			if (dir.datasize > 0) {
				lua_pushinteger(L, BackUpWrite((Uint32)lua_tointeger(L,1), &dir, data, (Uint8)lua_tointeger(L,4)) );
				return 1;
			}
		}
	}
	return 0;
}

//	Inputs
//		device, filename, data
//	Outputs
//		status

static int lua_BUP_Verify(lua_State *L)
{
	if (lua_gettop(L)==3 /*&& lua_isnumber(L,1)*/ && lua_isstring(L,2) ) {
		Uint8 *data = lua_isuserdata(L,3) ? (Uint8 *)lua_touserdata(L,3) : (lua_isstring(L,3) ? (Uint8 *)lua_tostring(L,3) : (Uint8 *)lua_tointeger(L,3) );
		if(data != NULL) {
			lua_pushinteger(L, BUP_Verify((Uint32)lua_tointeger(L,1), (Uint8 *)lua_tostring(L, 2), data) );
			return 1;
		}
	}
	return 0;
}

//	Inputs
//		device, filename, dir_size
//	Outputs
//		dircount, dirs

static int lua_BUP_Dir(lua_State *L)
{
	if (lua_gettop(L)==3 /*&& lua_isnumber(L,1)*/ && lua_isstring(L,2) /*&& lua_isnumber(L,3)*/ ) {
		Uint16 max = (Uint16)lua_tonumber(L,3);
		if(max > 0) {
			BupDir	dirs[max];
			Sint32 n = BUP_Dir((Uint32)lua_tointeger(L,1), (Uint8 *)lua_tostring(L, 2), max, dirs); 
			int i = 0;
			lua_pushinteger(L, n);
			lua_createtable (L, n, 0);
			for(i=0; i<n; i++) {
				lua_pushinteger(L, i+1);
				lua_createtable (L, 0, 6);
				
				lua_pushstring(L, "filename");      // key
				lua_pushlstring(L, (char *)dirs[i].filename, 12);// value
				lua_settable (L, -3);
	
				lua_pushstring(L, "comment");      // key
				lua_pushlstring(L, (char *)dirs[i].comment, 11);// value
				lua_settable (L, -3);
	
				setfield_Integer(L, dirs[i].language , "language");
				setfield_Integer(L, dirs[i].date     , "date");
				setfield_Integer(L, dirs[i].datasize , "datasize");
				setfield_Integer(L, dirs[i].blocksize, "blocksize");
				
				lua_settable (L, -3);
			}			
			return 2;
		}
	}
	return 0;
}



// as these don't work, because of the macros
//I_U32_O_S32(BUP_Format);
//I_U32_STR_O_S32(BUP_Delete);

int lua_BUP_Format(lua_State *L){
	if(lua_gettop(L)==1 && lua_isnumber(L, 1) ) {
		lua_pushinteger(L, BUP_Format( (Uint32)lua_tointeger(L, 1)) );
		return 1;
	}
	return 0;
}

int lua_BUP_Delete(lua_State *L){
    if(lua_gettop(L)==2 && lua_isnumber(L,1) && lua_isstring(L,2) ) {
		lua_pushinteger(L, BUP_Delete( (Uint32)lua_tointeger(L,1), (Uint8 *)lua_tostring(L,2) ) );
		return 1;
	}
	return 0;
}
//	Inputs
//		device, filename, buffer (size must be sufficient)
//	Outputs
//		dircount, dirs

int lua_BUP_Read(lua_State *L){
    if(lua_gettop(L)==3 /*&& lua_isnumber(L,1)*/ && lua_isstring(L,2) ) {
		Uint8 *b = lua_isuserdata(L,3) ? (Uint8 *)lua_touserdata(L,3) : (Uint8 *)lua_tointeger(L,3);
		if(b != NULL) {
			lua_pushinteger(L, BUP_Read( (Uint32)lua_tointeger(L,1), (Uint8 *)lua_tostring(L,2), b) );
			return 1;
		}
	}
	return 0;
}




void lua_MISC_register(lua_State *L)
{
	if(L != NULL) {
		lua_register(L, "Map2VRAM" 				, lua_Map2VRAM);
		lua_register(L, "getnewuserdata"        , lua_getnewuserdata);
		lua_register(L, "getintegerlocation"    , lua_getintegerlocation);
		lua_register(L, "getlongat"	    		, lua_getlongat);
		lua_register(L, "getshortat"    		, lua_getshortat);
		lua_register(L, "RB_CartRAM_init"    	, lua_RB_CartRAM_init);
		lua_register(L, "vblk_func_add"    		, lua_vblk_func_add);
		lua_register(L, "slIntFunction"    		, lua_vblk_func_add);// we must be able to add multiple functions (example: PCM + realtime gouraud)
		lua_register(L, "vblk_func_remove"    	, lua_vblk_func_remove);
		lua_register(L, "BackUpInit"    		, lua_BackUpInit);
		lua_register(L, "BUP_Stat"    			, lua_BUP_Stat);
		lua_register(L, "BackUpWrite"    		, lua_BackUpWrite);
		lua_register(L, "BUP_Verify"    		, lua_BUP_Verify);
		lua_register(L, "BUP_Dir"    			, lua_BUP_Dir);
		lua_register(L, "BUP_Format"    		, lua_BUP_Format);
		lua_register(L, "BUP_Delete"    		, lua_BUP_Delete);
		lua_register(L, "BUP_Read"    			, lua_BUP_Read);
	}
}
