
//#include "def.h"
#include <SGL.H>

#define SCREEN_HEIGHT 512	// max
void clearScreen()
{
    int i;
    for(i = 0; i < (SCREEN_HEIGHT / 16); i++)
        slPrint("                                            ", slLocate(0, i));
}

void my_ErrFunc(void *obj, Sint32 err_code)
{
    FIXED pos[XYZS] = {toFIXED(0.0), toFIXED(0.0), toFIXED(169.0), toFIXED(1.0)};
//    attr_Sprite.texno = GFS_MAX_GAMES + SPRITE_NUM;
    Uint16 data;
    
    clearScreen();
    if(obj != NULL)
        slPrint(obj, slLocate(10, 10));
    slPrint("Error code (HEX):", slLocate(5, 11));
    slPrintHex(err_code, slLocate(25, 11));
    slPrint("Error code (FIXED):", slLocate(5, 12));
    slPrintFX(err_code << 16, slLocate(25, 12));

	if( *(((char *)obj) + 2) == 'G') {
	    slPrint("This is a CD read error!", slLocate(5, 15));
	    slPrint("Please do not use CD-RW,", slLocate(5, 16));
	    slPrint("only use quality CD-R's", slLocate(5, 17));
	    slPrint("and slow recording speeds.", slLocate(5, 18));
	}
    do {
		data = Smpc_Peripheral[0].data;
//        getfirstPadInput(&data, NULL, NULL);
//        slDispSprite(pos, &attr_Sprite, DEGtoANG(0.0));
        slPrint("Press A button", slLocate(10, 13));
        slSynch();
    } while((data & PER_DGT_TA) != 0);
    
    do {
		data = Smpc_Peripheral[0].data;
//        getfirstPadInput(&data, NULL, NULL);
//        slDispSprite(pos, &attr_Sprite, DEGtoANG(0.0));
        slPrint("Press B button", slLocate(10, 13));
        slSynch();
    } while((data & PER_DGT_TB) != 0);
    clearScreen();
}


#include <SEGA_GFS.H>
void errGfsFunc(void *obj, Sint32 ec)
{
    // can happen if IMG of a game is not present
    if((ec == GFS_ERR_NEXIST) || (ec == GFS_ERR_FID))
        return;
	my_ErrFunc(obj == NULL ? "A GFS error occured!" : obj, ec);
}

void errStmFunc(void *obj, Sint32 ec)
{
	my_ErrFunc(obj == NULL ? "A STM error occured!" : obj, ec);
}

void errPcmFunc(void *obj, Sint32 ec)
{
	my_ErrFunc(obj == NULL ? "A PCM error occured!" : obj, ec);
}



// Lua Erro handling
//#include <stdarg.h>
//#include <stdio.h>
//#include <stdlib.h>
//
//void error (lua_State *L, const char *fmt, ...) {
//	va_list argp;
//	va_start(argp, fmt);
//	vfprintf(stderr, argp);
//	va_end(argp);
//	lua_close(L);
//	exit(EXIT_FAILURE);
//}
//
