-- data mapping guide

-- Saturn       Lua
-- ANGLE        integer
-- FIXED        float     ??? no good, all fixed ops mul/div/ done with float conversion
-- sin/cos      float
-- pointers     userdata/integers


--for lua_pos_dofile to work
gfsDirName, gfsLibWork, gfsDirN = GFS_Init(200, 10, 1)-- importand: assign return value to variables

function slLocate(x, y)
	return x, y
end

function toFIXED(v)
	return v
end	
-- SGL defines
scnNBG0 = 1
scnNBG1 = 0
scnNBG2 = 3
scnNBG3 = 2
scnRBG0 = 5
scnRBGA = 5
scnRBGB = 4
scnSPR  = 4
scnROT  = 7
scnCCAL = 6
function slPriorityNbg0(num) return slPriority(scnNBG0 , num) end
function slPriorityNbg1(num) return slPriority(scnNBG1 , num) end
function slPriorityNbg2(num) return slPriority(scnNBG2 , num) end
function slPriorityNbg3(num) return slPriority(scnNBG3 , num) end
function slPriorityRbg0(num) return slPriority(scnRBG0 , num) end
function slPrioritySpr0(num) return slPriority(scnSPR0 , num) end
function slPrioritySpr1(num) return slPriority(scnSPR1 , num) end
function slPrioritySpr2(num) return slPriority(scnSPR2 , num) end
function slPrioritySpr3(num) return slPriority(scnSPR3 , num) end
function slPrioritySpr4(num) return slPriority(scnSPR4 , num) end
function slPrioritySpr5(num) return slPriority(scnSPR5 , num) end
function slPrioritySpr6(num) return slPriority(scnSPR6 , num) end
function slPrioritySpr7(num) return slPriority(scnSPR7 , num) end

function slLocateNbg0(x,y) return slLocateNbg(x,y,scnNBG0) end
function slLocateNbg1(x,y) return slLocateNbg(x,y,scnNBG1) end
function slLocateNbg2(x,y) return slLocateNbg(x,y,scnNBG2) end
function slLocateNbg3(x,y) return slLocateNbg(x,y,scnNBG3) end

function slColRateNbg0(rate) return slColRate(scnNBG0 , rate) end
function slColRateNbg1(rate) return slColRate(scnNBG1 , rate) end
function slColRateNbg2(rate) return slColRate(scnNBG2 , rate) end
function slColRateNbg3(rate) return slColRate(scnNBG3 , rate) end
function slColRateRbg0(rate) return slColRate(scnRBG0 , rate) end
function slColRateLNCL(rate) return slColRate(scnLNCL , rate) end
function slColRateBACK(rate) return slColRate(scnBACK , rate) end
function slColRateSpr0(rate) return slColRate(scnSPR0 , rate) end
function slColRateSpr1(rate) return slColRate(scnSPR1 , rate) end
function slColRateSpr2(rate) return slColRate(scnSPR2 , rate) end
function slColRateSpr3(rate) return slColRate(scnSPR3 , rate) end
function slColRateSpr4(rate) return slColRate(scnSPR4 , rate) end
function slColRateSpr5(rate) return slColRate(scnSPR5 , rate) end
function slColRateSpr6(rate) return slColRate(scnSPR6 , rate) end
function slColRateSpr7(rate) return slColRate(scnSPR7 , rate) end

function slZoomModeNbg0(mode) return slZoomMode(scnNBG0 , mode) end
function slZoomModeNbg1(mode) return slZoomMode(scnNBG1 , mode) end


-- Window control
win_OR   = 0x80
win_AND  = 0x00
win0_IN  = 0x03
win0_OUT = 0x02
win1_IN  = 0x0c
win1_OUT = 0x08
spw_IN   = 0x30
spw_OUT  = 0x20
-- slScrDisp
NBG0ON  = bit.lshift(1,  0)
NBG1ON  = bit.lshift(1,  1)
NBG2ON  = bit.lshift(1,  2)
NBG3ON  = bit.lshift(1,  3)
RBG0ON  = bit.lshift(1,  4)
LNCLON  = bit.lshift(1,  5)
SPRON   = bit.lshift(1,  6)
BACKON  = bit.lshift(1,  5)
NBG0OFF = bit.lshift(1, 16)
NBG1OFF = bit.lshift(1, 17)
NBG2OFF = bit.lshift(1, 18)
NBG3OFF = bit.lshift(1, 19)
RBG0OFF = bit.lshift(1, 20)
-- BooleanSwitch
OFF = 0
ON  = 1

-- buttons
PER_DGT_KR = bit.lshift(1, 15)	-- Right Key
PER_DGT_KL = bit.lshift(1, 14)	--  Left Key
PER_DGT_KD = bit.lshift(1, 13)	--  Down Key
PER_DGT_KU = bit.lshift(1, 12)	--    Up Key
PER_DGT_ST = bit.lshift(1, 11)	-- Start
PER_DGT_TA = bit.lshift(1, 10)	-- A Trigger
PER_DGT_TC = bit.lshift(1,  9)	-- C Trigger
PER_DGT_TB = bit.lshift(1,  8)	-- B Trigger
PER_DGT_TR = bit.lshift(1,  7)	-- R Trigger
PER_DGT_TX = bit.lshift(1,  6)	-- X Trigger
PER_DGT_TY = bit.lshift(1,  5)	-- Y Trigger
PER_DGT_TZ = bit.lshift(1,  4)	-- Z Trigger
PER_DGT_TL = bit.lshift(1,  3)	-- L Trigger

--	Scroll V-RAM map address	--
VDP2_VRAM_A0 = 0x25e00000
VDP2_VRAM_A1 = 0x25e20000
VDP2_VRAM_B0 = 0x25e40000
VDP2_VRAM_B1 = 0x25e60000

VDP2_COLRAM = 0x25f00000

SpriteVRAM = 0x25c00000

-- similar naming scheme:
CPU_WRAM_LO		= 0x200000
CPU_WRAM_LO_LEN	= 0x100000

-- slInitSystem --
TV_320x224 = 0
TV_320x240 = 1
TV_320x256 = 2
--TV_dummy1  = 3
TV_352x224 = 4
TV_352x240 = 5
TV_352x256 = 6
--TV_dummy2  = 7
TV_640x224 = 8
TV_640x240 = 9
TV_640x256 = 10
--TV_dummy3  = 11
TV_704x224 = 12
TV_704x240 = 13
TV_704x256 = 14
--TV_dummy4  = 15
TV_320x448 = 16
TV_320x480 = 17
TV_320x512 = 18
--TV_dummy5  = 19
TV_352x448 = 20
TV_352x480 = 21
TV_352x512 = 22
--TV_dummy6  = 23
TV_640x448 = 24
TV_640x480 = 25
TV_640x512 = 26
--TV_dummy7  = 27
TV_704x448 = 28
TV_704x480 = 29
TV_704x512 = 30
--TV_dummy8  = 31
 
-- slColRAMMode --
CRM16_1024 = 0
CRM16_2048 = 1
CRM32_1024 = 2
-- slChar --
COL_TYPE_16    = 0x00
COL_TYPE_256   = 0x10
COL_TYPE_2048  = 0x20
COL_TYPE_32768 = 0x30
COL_TYPE_1M    = 0x40
CHAR_SIZE_1x1  = 0
CHAR_SIZE_2x2  = 1
-- slPage --
PNB_2WORD = 0
PNB_1WORD = 0x8000
CN_10BIT  = 0
CN_12BIT  = 0x4000
-- slPlane --
PL_SIZE_1x1 = 0
PL_SIZE_2x1 = 1
PL_SIZE_2x2 = 3
--/* slCurRpara */
--/* slRparaMode */
RA			= 0
RB			= 1
K_CHANGE    = 2
W_CHANGE    = 3



-- note: currently, ANGLEs are feed to the API as integers, ANGLE is Sint16
function DEGtoANG(d) return ((65536.0 * (d)) / 360.0) end
function RADtoANG(d) return ((65536.0 * (d)) / (2*3.1415926535897932384626433832795)) end

CURRENT = 0		--/* Current Matrix */


-- SEGA_BUP.H
BUP_LIB_ADDRESS    = 0x6000350+8
BUP_VECTOR_ADDRESS = 0x6000350+4

BUP_MAIN_UNIT = 1
BUP_CURTRIDGE = 2

BUP_JAPANESE  = 0
BUP_ENGLISH   = 1
BUP_FRANCAIS  = 2
BUP_DEUTSCH   = 3
BUP_ESPANOL   = 4
BUP_ITALIANO  = 5

BUP_NON               = 1
BUP_UNFORMAT          = 2
BUP_WRITE_PROTECT     = 3
BUP_NOT_ENOUGH_MEMORY = 4
BUP_NOT_FOUND         = 5
BUP_FOUND             = 6
BUP_NO_MATCH          = 7
BUP_BROKEN            = 8


---- sl_macro.h --
----/*  Macro define for slExtendScroll		*/
--
--_End_        = 0
--_LocateA0_   = 1
--_LocateA1_   = 2
--_LocateB0_   = 3
--_LocateB1_   = 4
--_Set_        = 5
--_Stock_      = 6
--_Same_       = 7
--_Inc_        = 8
--_Inc2_       = 9
--_Dec_        = 10
--_Dec2_       = 11
--_Vline_      = 12
--_VlineMinus_ = 13
--_Skip_       = 14
--_Skip2_      = 15
--_Copy_       = 16
--_RelCopy_    = 17
--_Fill_       = 18
--_Bra_        = 19
--_Bsr_        = 20
--_Rts_        = 21
--_Block_      = 22
--_BlockInc_   = 23
--_BlockInc2_  = 24
--_One_        = 25
--_High_       = 26
--_BlockFill_  = 27
--_Add_        = 28
--
--
--function End()          return _End_*4+0x80 end
--function LocateA0(adr)  return _LocateA0_*4+0x80, bit.rshift(bit.band(adr, 0x1fe00), 9) , bit.rshift(bit.band(adr, 0x1fe), 1) end
--function LocateA1(adr)  return _LocateA1_*4+0x80, bit.rshift(bit.band(adr, 0x1fe00), 9) , bit.rshift(bit.band(adr, 0x1fe), 1) end
--function LocateB0(adr)  return _LocateB0_*4+0x80, bit.rshift(bit.band(adr, 0x1fe00), 9) , bit.rshift(bit.band(adr, 0x1fe), 1) end
--function LocateB1(adr)  return _LocateB1_*4+0x80, bit.rshift(bit.band(adr, 0x1fe00), 9) , bit.rshift(bit.band(adr, 0x1fe), 1) end
--function Set(cnt)       return _Set_*4+0x80,   cnt - 1 end
--function Stock(cnt)     return _Stock_*4+0x80, cnt - 1 end
--function Same(cnt,chr)  return _Same_*4+0x80,  cnt - 1 , bit.rshift(chr, 8) , bit.band(chr, 0xff) end
--function Inc(cnt,chr)   return _Inc_*4+0x80,   cnt - 1 , bit.rshift(chr, 8) , bit.band(chr, 0xff) end
--function Inc2(cnt,chr)  return _Inc2_*4+0x80,  cnt - 1 , bit.rshift(chr, 8) , bit.band(chr, 0xff) end
--function Dec(cnt,chr)   return _Dec_*4+0x80,   cnt - 1 , bit.rshift(chr, 8) , bit.band(chr, 0xff) end
--function Dec2(cnt,chr)  return _Dec2_*4+0x80,  cnt - 1 , bit.rshift(chr, 8) , bit.band(chr, 0xff) end
--function Vline(cnt,chr) return _Vline_*4+0x80, cnt - 1 , bit.rshift(chr, 8) , bit.band(chr, 0xff) end
--function VlineMinus(cnt,chr) return _VlineMinus_*4+0x80, cnt - 1 , bit.rshift(chr, 8) , bit.band(chr, 0xff) end
--function Skip(offset)  return _Skip_*4+0x80, offset end
--function Skip2(offset) return _Skip2_*4+0x80, bit.rshift(offset, 8) , bit.band(offset, 0xff) end
--function Copy(src,cnt) return _Copy_*4+0x80,  bit.band(bit.rshift(src, 17), 0xff) , bit.band(bit.rshift(src, 9), 0xff) , bit.band(src, 0xff) , cnt - 1 end
--function RelCopy(src,cnt) return _RelCopy_*4+0x80, bit.rshift(src, 8) , bit.band(src, 0xff) , cnt - 1 end
--function Fill(cnt,chr) return _Fill_*4+0x80, bit.rshift(cnt-1, 8) , bit.band(cnt-1, 0xff), bit.rshift(chr, 8), bit.band(chr, 0xff) end
--function Bra(adr) return _Bra_*4+0x80, bit.rshift(adr, 8), bit.band(adr, 0xff) end
--function Bsr(adr) return _Bsr_*4+0x80, bit.rshift(adr, 8), bit.band(adr, 0xff) end
--function Rts() return _Rts_*4+0x80 end
--function Block(h,v) return _Block_*4+0x80,(h)-1,(v)-1 end
--function BlockInc(h,v,c) return _BlockInc_*4+0x80,(h)-1,(v)-1,(c) >> 8, bit.band(c, 0xff) end
--function BlockInc2(h,v,c) return _BlockInc2_*4+0x80,(h)-1,(v)-1,(c) >> 8, bit.band(c, 0xff) end
--function One(c) return _One_*4+0x80, bit.rshift(c, 8), bit.band(c, 0xff) end
--function High(cnt,chr) return _High_*4+0x80,(cnt)-1, bit.rshift(chr, 8), bit.band(chr, 0xff) end
--function BlockFill(h,v,c) return _BlockFill_*4+0x80,(h)-1,(v)-1, bit.rshift(c, 8), bit.band(c, 0xff) end
--function Add(cnt,add,chr) return _Add_*4+0x80, cnt - 1 , add , bit.rshift(chr, 8) , bit.band(chr, 0xff) end
--
--function Char1(c)                       return bit.rshift(c, 8) , bit.band(c, 0xff) end
--function Char2(c1,c2)                   return Char1(c1) ,          Char1(c2) end
--function Char3(c1,c2,c3)                return Char2(c1,c2) ,       Char1(c3) end
--function Char4(c1,c2,c3,c4)             return Char2(c1,c2) ,       Char2(c3,c4) end
--function Char5(c1,c2,c3,c4,c5)          return Char3(c1,c2,c3) ,    Char2(c4,c5) end
--function Char6(c1,c2,c3,c4,c5,c6)       return Char3(c1,c2,c3) ,    Char3(c4,c5,c6) end
--function Char7(c1,c2,c3,c4,c5,c6,c7)    return Char3(c1,c2,c3) ,    Char4(c4,c5,c6,c7) end
--function Char8(c1,c2,c3,c4,c5,c6,c7,c8) return Char4(c1,c2,c3,c4) , Char4(c5,c6,c7,c8) end
--
--function LChar1(c)                       return bit.band(c, 0xff) end
--function LChar2(c1,c2)                   return bit.band(c1, 0xff), bit.band(c2, 0xff) end
--function LChar3(c1,c2,c3)                return bit.band(c1, 0xff), bit.band(c2, 0xff), bit.band(c3, 0xff) end
--function LChar4(c1,c2,c3,c4)             return LChar2(c1,c2),      LChar2(c3,c4) end
--function LChar5(c1,c2,c3,c4,c5)          return LChar2(c1,c2),      LChar3(c3,c4,c5) end
--function LChar6(c1,c2,c3,c4,c5,c6)       return LChar3(c1,c2,c3),   LChar3(c4,c5,c6) end
--function LChar7(c1,c2,c3,c4,c5,c6,c7)    return LChar4(c1,c2,c3,c4),LChar3(c5,c6,c7) end
--function LChar8(c1,c2,c3,c4,c5,c6,c7,c8) return LChar4(c1,c2,c3,c4),LChar4(c5,c6,c7,c8) end
--
