//                                                                                
//    Copyright (c) 2006 Thomas Fuchs / The Rockin'-B, www.rockin-b.de       
//                                                                                
//    Permission is granted to anyone to use this software for any purpose        
//    and to redistribute it freely, subject to the following restrictions:       
//                                                                                
//    1.  The origin of this software must not be misrepresented. You must not    
//        claim that you wrote the original software. If you use this software    
//        in a product, an acknowledgment in the product documentation would be   
//        appreciated but is not required.                                        
//                                                                                
//    2.  ANY COMMERCIAL USE IS PROHIBITED. This includes that you must not use   
//        this software in the production of a commercial product. Only an explicit
//        permission by the author can allow you to do that.                      
//                                                                                
//    3.  Any modification applied to the software must be marked as such clearly.
//                                                                                
//    4.  This license may not be removed or altered from any distribution.       
//                                                                                
//                                                                                
//    			    NO WARRANTY                                                 
//                                                                                
//    THERE IS NO WARRANTY FOR THE PROGRAM.                                       
//    THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,               
//    EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,                 
//    THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE.                 
//    THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
//    SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY    
//    SERVICING, REPAIR OR CORRECTION.                                            
//                                                                                
//    IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES,         
//    INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
//    OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED   
//    TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY    
//    YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER  
//    PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE       
//    POSSIBILITY OF SUCH DAMAGES.                                                
//                                                                                

#include <stdlib.h>

#include "lua.h"
#include "lauxlib.h"

#include "minilzo.h"
#include "lzopak.h"

#include "alloc.h"

#include <SGL.H>




#ifdef MAKE_PAR_BINARY

#include <SEGA_CDC.H>
/* for initializing the CD-ROM when testing with PAR */
#define SYS_CDINIT1(i)		((**(void(**)(int))0x60002dc)(i))
#define SYS_CDINIT2()		((**(void(**)(void))0x600029c)())
int CdUnlock (void)
{
     Sint32 ret;
     CdcStat stat;
     volatile int delay;

     SYS_CDINIT1(3);

     SYS_CDINIT2();

     do {
          for(delay = 100000; delay; delay--);

          ret = CDC_GetCurStat(&stat);

     } while ((ret != 0) || (CDC_STAT_STATUS(&stat) == 0xff));

     return (int) CDC_STAT_STATUS(&stat);
}
#endif


#undef snprintf

//void init_LZO()
//{
//    if (lzo_init() != LZO_E_OK)
//		slPrint("LZO init failed!!", slLocate(2, 3));
//}



	char startup_lua_script[] = {
#	include "startup.c"
	};

#ifdef MAKE_PAR_BINARY
	char hardcoded_lua_script[] = {
#	include "hardcoded.c"
	};
#endif




lua_State *L;

LUALIB_API int luaopen_bit (lua_State *L);

extern void lua_GFS_register(lua_State *L);
extern void lua_STM_register(lua_State *L);
extern void lua_PCM_register(lua_State *L);
extern void lua_SGL_register(lua_State *L);
//extern void lua_LZOPAK_register(lua_State *L);
extern void lua_MISC_register(lua_State *L);
extern void lua_API_register(lua_State *L);

int lua_sat_open()
{
	L = lua_open();
	
//	luaL_openlibs(L);
//	lua_getfield(L, LUA_GLOBALSINDEX, "luaopen_base"); /* function to be called */
//	lua_call (L, 0, 0);
//
	luaopen_base(L);
//	luaopen_package(L);
	luaopen_string(L);
	luaopen_table(L);
	luaopen_math(L);
//	luaopen_io(L);
//	luaopen_debug(L);
//	luaopen_base(L);
	luaopen_bit(L);
	
//	slPrint("Lua opened", slLocate(5, 2));

	
	lua_GFS_register(L);
	lua_STM_register(L);
	lua_PCM_register(L);
	lua_SGL_register(L);
//	lua_LZOPAK_register(L);
	lua_MISC_register(L);
//slPrint("Here1", slLocate(10, 10));
	lua_API_register(L);
//slPrint("Here2", slLocate(10, 11));

//	slPrint("C-API registered", slLocate(5, 3));

	// for lua_pos_dofile to work
//	luaL_dostring(L, "gfsDirName, gfsLibWork, gfsDirN = GFS_Init(200, 10, 1)");// importand: assign return value to variables
	luaL_dostring(L, startup_lua_script);
//slPrint("Here3", slLocate(10, 12));

//	slPrint("GFS initialized", slLocate(5, 4));

//	luaL_dostring(L, "print(\"Hello from CD!!!\",\"A string\", true, false, 1234)");
	// error handling:
//	lua_atpanic
// Application code: lua_cpcall for protected mode execution of all C code..... lua.c, reference manual
// Library code: Whenever a C function detects an error, it simply calls lua_error, (or better yet luaL_error, which formats the error message and then calls lua_error). The lua_error function clears whatever needs to be cleared in Lua and jumps back to the lua_pcall that originated that execution, passing along the error message. 
}







int lua_sat_dofile(char *filename)
{
#ifdef MAKE_PAR_BINARY
	if (luaL_dostring(L, hardcoded_lua_script) != 0) {
#else
	if (luaL_dofile(L, filename) != 0) {
#endif
		char *err = (char *)lua_tostring(L,-1);
//	if (luaL_dostring(L,"print(\"Hello\",\"A string\", true, false, 1234)")!=0) {
		slPrint("Lua exited with error:", slLocate(5, 20));
		slPrint(err   , slLocate(0, 21));
		slPrint(err+40, slLocate(0, 22));
		slPrint(err+80, slLocate(0, 23));
		slPrint(err+120, slLocate(0, 24));
	} else
		slPrint("Lua exited successfully", slLocate(5, 25));
}

void lua_sat_close()
{
	lua_close(L);
}






void check_WORKAREA()
{
	Uint32 i, msk;
	int lin = 5;

	extern const void*   WorkAreaEnd;
	extern const void*   TransList;
	
	if((Uint32)WorkAreaEnd > (Uint32)TransList) {
		slPrint("WORKAREA.c: memory is overlapping!", slLocate(5, lin++));
		slPrint("WorkAreaEnd:", slLocate(10, lin));
		slPrintHex((Uint32)WorkAreaEnd, slLocate(25, lin++));
		slPrint("TransList:", slLocate(10, lin));
		slPrintHex((Uint32)TransList, slLocate(25, lin++));
		slPrint("Please update #define WORK_AREA", slLocate(5, lin++));
	}
	
	// SortList and TransList and power of 2 location ?
	for(i=0, msk=0; i<=31; i++, msk=(msk<<1)|1 ) {
		if (SortListSize <= (1 << i) )
			break;
	}
	if( ((Uint32)SortList & msk) != 0) {
		slPrint("WORKAREA.c: SortList not aligned properly!", slLocate(5, lin++));
		slPrint("Please ensure alignment at this boundary:", slLocate(5, lin++));
		slPrintHex(msk+1, slLocate(5, lin++));
	}
	if( ((Uint32)TransList & 0xFF) != 0) {
		slPrint("WORKAREA.c: TransList not aligned properly!", slLocate(5, lin++));
		slPrint("Please ensure alignment at this boundary:", slLocate(5, lin++));
		slPrintHex(0xFF+1, slLocate(5, lin++));
	}
	if( ((Uint32)Zbuffer & 0x3) != 0) {
		slPrint("WORKAREA.c: Zbuffer not aligned properly!", slLocate(5, lin++));
		slPrint("Please ensure alignment at this boundary:", slLocate(5, lin++));
		slPrintHex(0x3+1, slLocate(5, lin++));
	}
	if( ((Uint32)CLOfstBuf & 0x3) != 0) {
		slPrint("WORKAREA.c: CLOfstBuf not aligned properly!", slLocate(5, lin++));
		slPrint("Please ensure alignment at this boundary:", slLocate(5, lin++));
		slPrintHex(0x3+1, slLocate(5, lin++));
	}
	
	if(lin > 5) {
		while(1)
			slSynch();
	}
}


#include "vblank.h"

void ss_main()
{
	slInitSystem(TV_320x224, NULL, 2);

//	slPrint("Here I am !!!", slLocate(5, 8));
//	while(1)
//		slSynch();

//	slTVOn();
	init_ALLOC();
//	init_LZO();
#ifdef MAKE_PAR_BINARY
	// BEFORE any CD access (lua_pos_open(), init_GFX())
	CdUnlock();
#endif
	lua_sat_open();

	
	vblk_func_add(vblk_check_exit);
	slIntFunction(vblk_execute);
//slPrint("Here4", slLocate(10, 13));
	
	// test WORKAREA.c
	check_WORKAREA();

//slPrint("Here5", slLocate(10, 14));

	lua_sat_dofile("0.LUA");// what if alloc fails ?
//slPrint("Here6", slLocate(10, 15));
	lua_sat_close();
		
	{
		int i;
		slPrint("Exiting to multiplayer...", slLocate(5, 29));
		while(1)//debugging
		//for(i=30*10; i > 0; i--)
			slSynch();
   		// return to multiplayer
    	SYS_Exit(0);    
	}
}

#if 1
#include <SGL.H>
/*********************************/
/* taken from cinit.c */
/*********************************/
#define		SystemWork		0x060ffc00		/* System Variable Address */
#define		SystemSize		(0x06100000-0x060ffc00)		/* System Variable Size */
/* sl.lnk Ŏw肵.bssZNV̊JnAIV{ */
extern unsigned int _bstart, _bend;
extern unsigned int _lstart, _lend;
 
int main( void )
{
	Uint8	*dst;
	Uint32	i; 

	/* 1.Zero Set .bss Section */
	for( dst = (Uint8 *)&_bstart; dst < (Uint8 *)&_bend; dst++ ) {
		*dst = 0;
	}
	
	/* 2.ROM has data at end of text; copy it. */

	/* 3.SGL System Variable Clear */
	for( dst = (Uint8 *)SystemWork, i = 0;i < SystemSize; i++) {
		*dst = 0;
	}

	/* Application Call */
	ss_main();
	return 1;
}
#endif

