#include <stdlib.h>

#include "vblank.h"

vblk_func vblk_func_registry[VBLK_FUNC_MAX] = {
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};


int vblk_func_add(vblk_func f)
{
	int i;
	for(i = 0; i < VBLK_FUNC_MAX; i++) {
		if(vblk_func_registry[i] == NULL) {
			vblk_func_registry[i] = f;
			return i;
		}
	}
	return -1;//failed to register
}

int vblk_func_remove(vblk_func f)
{
	int i;
	for(i = 0; i < VBLK_FUNC_MAX; i++) {
		if(vblk_func_registry[i] == f) {
			vblk_func_registry[i] = NULL;
			return i;
		}
	}
	return -1;//not found
}

// can only register one function with
// slIntFunction();
// so a wrapper for multiple functions is needed

void vblk_execute()
{
	int i;
	for(i = 0; i < VBLK_FUNC_MAX; i++) {
		if(vblk_func_registry[i] != NULL)
#ifdef VBLK_FUNC_LUA			
			vblk_func_registry[i](NULL);
#else
			vblk_func_registry[i]();
#endif
	}
}

#include <SGL.H>
#define MASK	(PER_DGT_ST | PER_DGT_TA | PER_DGT_TB | PER_DGT_TC)

#ifdef VBLK_FUNC_LUA
#	include "lua.h"
int vblk_check_exit(lua_State *L)
#else
void vblk_check_exit()
#endif
{	
	Uint16 data = ~Smpc_Peripheral[0].data;
//	if(data & PER_DGT_ST && data & PER_DGT_TA && data & PER_DGT_TB && data & PER_DGT_TC)
	if((data & MASK) == MASK)
		SYS_Exit(0);
}
